;;;        
(defun C:AVP (/
	      Application
	      ActiveDocument
	      CenterPointViewport
	      FrameHeight
	      FrameWidth
	      LayoutName
	      PaperSpace
	      Point1
	      Point2
	      Point1x
	      Point1y
	      Point2x
	      Point2y
	      Scale
	      Viewport
	      ViewportHeight
	      ViewportWidth	      
		 )
  (vl-load-com) ;   ActiveX
  (setq Application (vlax-get-acad-object) ;  
	ActiveDocument (vla-get-ActiveDocument Application) ;   
	PaperSpace (vla-get-PaperSpace ActiveDocument) ;   
	)
  (if (= (getvar "CTAB") "Model")
    (progn
      (alert "   .") ;      
      (quit)
      )
    (setq LayoutName (getvar "CTAB")) ;   
    )
  (while T
    (setvar "CTAB" "Model") ;    
    (setq Point1 (getpoint "  ")) ;    
    (setq Point2 (getcorner Point1 "  ")) ;    
    (initget 6) (setq Scale (getreal " 1:<1>")) ;  
    (if (not Scale) (setq Scale 1))
    (setvar "CTAB" LayoutName) ;    
    (setq
      FrameWidth (abs (- (car Point1) (car Point2))) ;   
      FrameHight (abs (- (cadr Point1) (cadr Point2))) ;   
      ViewportWidth (/ FrameWidth Scale) ;    
      ViewportHight (/ FrameHight Scale) ;    
      PaperSpace (vla-get-paperspace ActiveDocument)
      Point1x (car Point1) ;    
      Point1y (cadr Point1)
      Point2x (car Point2)
      Point2y (cadr Point2)
      )	 
    ;(setq PointViewport (getpoint "    "))
    (setq CenterPointViewport (list (/ ViewportWidth 2) (/ ViewportHight 2) 0))  ;         
    (setq Viewport (vla-AddPViewport PaperSpace (vlax-3d-point CenterPointViewport) ViewportWidth ViewportHight)) ;  
    (vla-display Viewport :vlax-true) ;   
    (vla-put-mspace ActiveDocument :vlax-true) ;     
    (vla-zoomcenter Application (vlax-3d-point (list (/ (+ Point1x Point2x) 2) (/ (+ Point1y Point2y) 2))) 1.0) ;   
    (vla-put-mspace ActiveDocument :vlax-false) ;   
    (vla-put-standardscale Viewport acVpCustomScale) ;     
    (vla-put-DisplayLocked Viewport "-1") ;   
    (vla-put-CustomScale Viewport (/ (float 1) (float Scale))) ;    
    (command "._move" (vlax-vla-object->ename Viewport) "" "0,0" pause) ;     
    )
  )