 
; ----------------------------------------------------------------------------------------------------------------------------------------------
(vl-load-com)
(defun c:Align-Point-by-Way( / )
  ((lambda(main_put)
     (if (= (type main_put) 'ENAME)
       ((lambda(lst_points)
	  (if lst_points
	    (foreach point lst_points
	      ((lambda(point_on_curve)
		 (if point_on_curve
		   ((lambda(ang)
		      (if (and ang
			       (not (vl-catch-all-error-p ang))
			       )
			(progn
			  (vlax-put-property point 'Rotation ang)
			  (vlax-put-property point 'LabelRotation ang)
			  )
			)
		      )
		     (_tdg-get-reanim_ang_rad main_put point_on_curve 0)
		     )
		   )
		 )
		(vlax-curve-getClosestPointTo main_put (vlax-safearray->list (vlax-variant-value (vlax-get-property point 'Location))))
		)
	      )
	    )
	  )
	 (get-list-point)
	 )
       )
     )
    (_tdg-get-object-byselect "\n : " '("LWPOLYLINE" "POLYLINE" "AECC_ALIGNMENT") nil)
    )
); end c:Align-Point-by-Way
; ----------------------------------------------------------------------------------------------------------------------------------------------

; ----------------------------------------------------------------------------------------------------------------------------------------------
(defun _tdg-get-object-byselect(message filter lock_enter / return)
  ((lambda(errnovar)
     (setvar "errno" 0)
     (while (not (setq return ((lambda(obj)
                                 (if (not (vl-catch-all-error-p obj))
                                   (if obj
                                     (if filter
                                       (if (member (strcase (cdr (assoc 0 (entget (car obj))))) (mapcar 'strcase filter))
                                         (car obj)
                                         )
                                       (car obj)
                                       )
                                     (if (and (not lock_enter) (= (getvar "errno") 52))
                                       0
                                       )
                                     )
                                   1
                                   )
                                 )
                                (vl-catch-all-apply 'entsel
                                                    (list (strcat "\n" message))
                                                    )
                                )
                       )
                 )
       )
     (setvar "errno" errnovar)
     return
     )
    (getvar 'errno)
    )
  ); end _tdg-get-object-byselect
; ----------------------------------------------------------------------------------------------------------------------------------------------

; ----------------------------------------------------------------------------------------------------------------------------------------------
(defun _tdg-get-reanim_ang_rad(obj point ang / )
  (vl-catch-all-apply
    (function
      (lambda()
        (+ (angle '(0.0 0.0 0.0)
                  (vlax-curve-getFirstDeriv obj
                                            (vlax-curve-getParamAtPoint obj
                                                                        (vlax-curve-getClosestPointTo obj point)
                                                                        )
                                            )
                  )
           ang
           )
        )
      )
    )
  ); end _tdg-get-reanim_ang_rad
; ----------------------------------------------------------------------------------------------------------------------------------------------

; ----------------------------------------------------------------------------------------------------------------------------------------------
(defun get-list-point( / nomutt)
  ((lambda(nbr_select_point)
     (setvar 'nomutt nomutt)
     ((lambda(nbr)
	(if nbr
	  (mapcar 'vlax-ename->vla-object (vl-remove-if 'listp (mapcar 'cadr (ssnamex nbr))))
	  )
	)
       (if nbr_select_point
	 nbr_select_point
	 (ssget "_X" '((0 . "AECC_COGO_POINT")))
	 )
       )
     )
    (progn
      (prompt "\n  <>: ")
      (setq nomutt (getvar 'nomutt))
      (setvar 'nomutt 1)
      (vl-catch-all-apply 'ssget
	(list '((0 . "AECC_COGO_POINT")))
	)
      )
    )
  ); end get-list-point
; ----------------------------------------------------------------------------------------------------------------------------------------------

