(vl-load-com)
;|============================================================================= 
*	  Z  ,   .
*	     
*	 :
		
*	 :
		(pl-error-restore-sysvar)
*	:
		   ,  
		     
=============================================================================|; 
;_ 
(defun Find_Z_OnLine (/ XY1 XY2 Z1 Z2 Pt1 Pt2 Pt3)

  ;_ *****   "" **************
  (setq *error* pltool-err)
  (setq	osm (getvar "OSMODE")
  )
  (or *pl-activedoc*
      (setq *pl-activedoc*
	     (vla-get-activedocument (vlax-get-acad-object))
      )
  )
  (vla-startundomark *pl-activedoc*)
  (pl-error-save-sysvar
    (list '("ANGBASE" 0)
	  '("ANGDIR" 0)
	  '("UCSFOLLOW" 0)
	  '("UCSICON")
	  '("CLAYER")
;;;	  '("osmode" 512)
;;;	  '("CMDECHO" 0)
	  (list "pickbox" (apply 'max (list 7 (getvar "pickbox"))))
	  (list "aperture" (getvar "pickbox"))
    )
  )
  ;_ **************************************
  
  (initget 1)
  (if (setq XY1	(getpoint "\n 1- : ")
	    Z1	(getreal "\n  Z   : ")
      )
    (progn
      (setq
	Pt1 (append (list (nth 0 XY1)) (list (nth 1 XY1)) (list Z1))
	XY2 (getpoint XY1 "\n 2- : ")
      )
      ;_  ,  
      (pl-error-save-sysvar
	(list '("CECOLOR" "4"))
      )
      (setq *pl-entLast*
	     (entmakex (list (cons 0 "LINE")
			     (cons 8 (getvar "CLAYER"))
			     (cons 10 XY1)
			     (cons 11 XY2)
		       )
	     )
      )
      (if (setq	Z2  (getreal "\n  Z   : "))
	(progn
	  ;_    ,     
	  (pl-error-save-sysvar
	    (list '("ORTHOMODE" 1)
		  (append '("SNAPANG" ) (list (angle XY1 XY2))))
	    )
	  
	  (setq
	    Pt2
	     (append (list (nth 0 XY2)) (list (nth 1 XY2)) (list Z2))
	  )
	  (setq	Pt3 (getpoint XY2 "\n  : ")
	  )
	  ;_        -    
	  (if (not (dwgru-geom-point-on-line Pt3 XY1 XY2))
	    (setq
	      Pt3 (inters XY1
			  XY2
			  Pt3
			  (polar Pt3 (+ (angle XY1 XY2) (/ Pi 2)) 7)
			  nil
		  )
	    )
	  ) ;_ end if

	  
	  
	  (princ "\n   <X, Y, Z>: ")
	  (mapcar '(lambda (x)
		     (terpri)
		     (princ (rtos x 2 2)) ;_     
		   )
		  (New_Z_OnLine Pt1 Pt2 Pt3)
	  )
	) ;_ end progn
	(princ "\n    Z.  .")
      ) ;_ end if
    ) ;_ end progn
    (princ "\n    Z.  .")
  ) ;_ end if

  ;_ *****    *************************
  (pl-error-restore-sysvar)
  (vla-endundomark *pl-activedoc*)
  (SSSETFIRST)
  ;_ *************************************************************
  (princ)
)

 ;|===========================================================================
*	  Z-   ,   
*	 :
		Point	-  ,     Z
		Pt1 	-  1-   
		Pt2 	-  2-   
*	:  
============================================================================|;
(defun New_Z_OnLine (Pt1 Pt2 Point / X X1 X2 Z Z1 Z2)
  (if (and Point Pt1 Pt2)
    (progn
      (setq X  (nth 0 Point)
	    X1 (nth 0 Pt1)
	    Z1 (nth 2 Pt1)
	    X2 (nth 0 Pt2)
	    Z2 (nth 2 Pt2)
      ) ;_ end setq
      (if (eq 0 (- X2 X1))
	(setq Z Z1)
	(setq Z (+ (* (/ (- X X1) (- X2 X1)) (- Z2 Z1)) Z1))
 ;_ Z = ((X-X1)/(X2-X1))*(Z2-Z1) + Z1
      ) ;_end if
      (setq Point (reverse (append (list Z) (cdr (reverse Point)))))
    ) ;_ end progn
  ) ;_ end if
) ;_ end defun new_Point

;| =========================================================================
*	 DWGruLispLib Copyright 2007  DWGru Programmers Group
*	dwgru-geom-point-on-line
*	07/12/2007  0001.    (VVA)
*	 :
		P   
		P1, P2   
	:  t,     
===========================================================================|;
(defun dwgru-geom-point-on-line (P P1 P2)
 (equal (+ (distance P P1) (distance P P2)) (distance P1 P2) 1e-6)
)

;|============================================================================= 
*	    .   (*pl-sysvar-list*)
*	 ,   ,  .
*	  *pl-sysvar-list*  ,     
*	 .
*	 :
		*pl-sysvar-list*	-   ,    .
					   ( )
		    .       .
		      nil,  
		   .
*	 :
		(kpblc-error-sysvar-list (list '("cmdecho" 0) '("blipmode") '("osmode" 503)))
=============================================================================|; 
(defun pl-error-save-sysvar (sysvar-list /)
  (foreach item	sysvar-list
    (setq *pl-sysvar-list*
	   (cons (list (car item) (getvar (car item)))
		 *pl-sysvar-list*
	   )
    )
    (if	(cadr item)
      (_pl-sysvar-set (car item) (cadr item))
    ) ;_ end of if
  ) ;_ end of foreach
) ;_ end of defun

;|============================================================================= 
*	  .   
* 	     *pl-sysvar-list*.   
* 	(nil),   .
*	 :
		
*	 :
		(pl-error-restore-sysvar)
=============================================================================|; 
(defun pl-error-restore-sysvar ()
  (if *pl-sysvar-list*
    (foreach item *pl-sysvar-list*
      (_pl-sysvar-set (car item) (cadr item))
    )
  )
  (setq *pl-sysvar-list* nil)

  ;_   
  (if *pl-entLast*
    (progn
      (entdel *pl-entLast*)
      (setq *pl-entLast* nil)
    )
  )
  (gc)
) ;_ end of defun

;|============================================================================= 
*	  .   (setvar)    
*	 : 
		sysvar	-    
		value	-   
*	 : 
		     nil   
=============================================================================|; 
(defun _pl-sysvar-set (sysvar value)
  (if (getvar sysvar)			;      ? 
    (if	(and (= value "") (wcmatch (strcase sysvar t) "dim*")) ;_ end of and 
      (setvar sysvar ".")
      (vl-catch-all-apply 'setvar (list sysvar value))
    )
  )
  (getvar sysvar)
) ;_ end of defun

;|==============================================================
*       AutoCAD
==============================================================|;
(defun pltool-err (msg)
  (if (member msg
	      '("console break"		  "Function cancelled"
		" "	  "quit / exit abort"
		" "
	       )
      )
    (princ "\n  ")
    (princ
      (strcat "\ERRNO # "
	      (itoa (getvar "ERRNO"))
	      ": "
	      msg
	      "\n"
      )
    )
  )
;;;    
  (while (> (getvar "CMDACTIVE") 0) (command))
  (pl-error-restore-sysvar)
  (vla-endundomark *pl-activedoc*)
  (SSSETFIRST)
  (if acet-ui-progress-done
    (acet-ui-progress-done)
  )
  (vl-cmdf "_.redrawall")
  (princ)
) ;_ end of defun