;;Background tools
;|
Ver. 2.0
 
BGLAYDEL -       
BG1BLEXP -  ,     (  )
BGBLEXP -     ,   ,     
BGBLEXP1 -   1- ,     
BGBLEXP1NOATT -   1- ,     
BGBLXCLIP -   
=======================================
BGCOLOR -     
BGBLCC -    
BGENCC -     
BGCATT -     
BGCBL2 -     2    ( )
BGBLFIX -  

    ,       
     BGBLXCLIP.
:
1.0 -   burst -     ,        
                                       0 ,   .
        Burst LineWeight
1.1        ( ;;; Change VVA 12.09.2008)
...
1.4    
1.11 ChangeAllObjectsColor -  , leader  mtext    .
     BGBLEXP -     (    )
     BG1BLEXP -  ,     
     -   A$C*
     -          
1.12 -   ,   /  
           1    ,   "0"
2.0  - BGBLEXP -    
|;

(vl-load-com)

(defun bg:purge-layer-filter ()
;;;Purge layer filter
;;;     
  (mapcar '(lambda (dictionary)
             (vl-catch-all-apply
               '(lambda ()
                  (vla-remove
                    (vla-getextensiondictionary
                      (vla-get-layers
                        (vla-get-activedocument
                          (vlax-get-acad-object)
                        ) ;_ end of vla-Get-ActiveDocument
                      ) ;_ end of vla-Get-Layers
                    ) ;_ end of vla-GetExtensionDictionary
                    dictionary
                  ) ;_ end of vla-Remove
                ) ;_ end of lambda
             ) ;_ end of vl-Catch-All-Apply
           ) ;_ end of lambda
          '("ACLYDICTIONARY" "ACAD_LAYERFILTERS" "ACAD_LAYERSTATES")
  ) ;_ end of mapcar
) ;_ end of defun
(defun bg:purge-groups ( / grpList index grp)
;; - bg:purge-groups
;;    
;;  []:
;;   
;; : Nil
  (setq grpList (dictsearch (namedobjdict) "ACAD_GROUP"))
  (setq index 1)
  (while (setq grp (nth index grplist))
    (if  (= (car grp) 3)
      (entdel (cdr (nth (+ index 1) grplist)))
    )
    (setq index (+ 1 index))
  )
  (princ)
  )
(defun bg:purge-AllPageSetups (/ pc)
  ;;;  page setups
  (vlax-for pc (vla-get-plotconfigurations (vla-get-activedocument (vlax-get-acad-object)))
    (vla-delete pc)
  )
)

(defun bg:purge-apps ( / Blk Obj appid)
;;;  
(vlax-for Blk (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object)))
    (if (= (vla-get-isxref Blk) :vlax-false)
      (progn
        (grtext -1
                (strcat "Inspecting objects: "
                        (vla-get-name Blk)
                ) ;_ end of strcat
        ) ;_ end of grtext

        (vlax-for Obj Blk (bg:del-XDATA-from-ename Obj nil))
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of vlax-for
(vlax-for appid (vla-get-registeredapplications
		    (vla-get-activedocument
		      (vlax-get-acad-object)
		    )
		  )
    (vl-catch-all-apply 'vla-delete (list appid))
  )  
  )
(defun bg:purge-ACADVBA ()
  (dictremove (namedobjdict) "ACAD_VBA")
  (princ)
)
(defun bg:purge-all ()
  (grtext -1 "Audit ... ")
  (vla-auditinfo (vla-get-activedocument (vlax-get-acad-object)) :vlax-true)  
  (grtext -1 "purge layer filter")
  (bg:purge-layer-filter)
  (grtext -1 "purge groups")
  (bg:purge-groups)
  (grtext -1 "purge Page Setups")
  (bg:purge-AllPageSetups)
  (bg:purge-ACADVBA)
  (grtext -1 "purge Apps")
  (bg:purge-apps)
  (repeat 3 (vla-purgeall (vla-get-activedocument (vlax-get-acad-object))))
  (command "_.Regenall")
  )
(defun bg:progress-init (msg maxlen)
  ;;; msg -    
  ;;; maxlen -  
  (or *BG:PROGRESS:OM* (setq *BG:PROGRESS:OM* (getvar "MODEMACRO")))
  (setq *BG:PROGRESS:MSG* (vl-princ-to-string msg))
  (setq *BG:PROGRESS:MAXLEN* maxlen)
  (setq *BG:PROGRESS:LPS* '-1)(princ)
  )
(defun bg:progress ( currvalue / persent str1 count)
  (if *BG:PROGRESS:MAXLEN*
    (progn
  (setq persent (fix (/ currvalue 0.01 *BG:PROGRESS:MAXLEN*)))
  ;;; 5 %
  (setq count (fix(* persent 0.2)))
  (setq str1 "")
  (if (/= count *BG:PROGRESS:LPS*)
    (progn
      ;;(setq str1 "")
      (repeat persent (setq str1 (strcat str1 "|")))
      )
    )
       ;;; currvalue -  
      (setvar "MODEMACRO"
              (strcat (vl-princ-to-string *BG:PROGRESS:MSG*)
                      " "
                      (itoa persent)
                      " % "
                      str1
                      )
              )
      (setq *BG:PROGRESS:LPS* persent)
  )
    )
  )
     
(defun bg:progress-clear ()
  (setq *BG:PROGRESS:MSG* nil)
  (setq *BG:PROGRESS:MAXLEN* nil)
  (setq *BG:PROGRESS:LPS* nil)
  (setvar "MODEMACRO" (vl-princ-to-string *BG:PROGRESS:OM*))
  ;;;(vla-regen (vla-get-activedocument (vlax-get-acad-object)) acactiveviewport)
  (princ)
  )
;;;;     -
;;;;title - 
;;;;message - 
;;;;  t - 
;;;;            nil - 
;;;  (bg:MSG-YES-NO "" "  ?")
;;;(defun bg:msg-yes-no ( title message / usri1 ret)
;;;(setq usri1 (getvar "USERI1"))
;;;(SETVAR "USERI1" 0)
;;;(command "_vbastmt"
;;;(strcat "ThisDrawing.SetVariable \"USERI1\", "
;;;"MsgBox \(\""
;;;message
;;;"\","
;;;(itoa vlax-VBYesNo)
;;;",\""
;;;title
;;;"\"\)"
;;;)
;;;)
;;;(setq ret (= (getvar "USERI1") 6))
;;;(SETVAR "USERI1" usri1)
;;;ret	 
;;;)
;;;  http://msdn2.microsoft.com/en-us/library/x83z1d9f.aspx
;;; intButton = object.Popup(strText,[nSecondsToWait],[strTitle],[nType])

;;;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;;;  nType   + 

;;;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;;; 
;;;0 - Show OK button.
;;;1 - Show OK and Cancel buttons.
;;;2 - Show Abort, Retry, and Ignore buttons.
;;;3 - Show Yes, No, and Cancel buttons.
;;;4 - Show Yes and No buttons.
;;;5 - Show Retry and Cancel buttons.

;;;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;;;  Icon Types
;;;16 - Show "Stop Mark" icon.
;;;32 - Show "Question Mark" icon.
;;;48 - Show "Exclamation Mark" icon.
;;;64 - Show "Information Mark" icon.

;;;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;;; intButton  

;;;1 - OK button
;;;2 - Cancel button
;;;3 - Abort button
;;;4 - Retry button
;;;5 - Ignore button
;;;6 - Yes button
;;;7 - No button
;;;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
(defun bg:msg-yes-no ( title message / WScript ret)
(setq WScript (vlax-get-or-create-object "WScript.Shell"))
(setq ret (vlax-invoke-method WScript "Popup" message "0" title (+ 4 48)))
(vlax-release-object WScript)
(= ret 6)  
)

;|
(defun bg:msg-yes-no ( title message)
  (= (mip_button2 title message "exclam" "Yes" "No") "Yes")
)

(defun mip_button2 ( TITLE$ MSG$ ICON$ Button1$ Button2$ / fl ret i tmp DCL_ID% maxlen)
  ;;;;       Terry Miller
  ;;;; Program Name: GetIcon.lsp [Get Icon R6]
  ;;;; Created By:   Terry Miller (Email: terrycadd@yahoo.com)
  ;;;;               (URL: http://web2.airmail.net/terrycad)

  ;;;TITLE$ - , 
  ;;;MSG$   - , ,  \n

  ;;;ICON$  - .  
  ;;;                 "" -  
  ;;;                 "DELETE" -  
  ;;;                 "ALERTX" -  X   
  ;;;                 "EXCLAM" - 
  ;;;                 "LIGHT"  - 
  ;;;                 "INFORM" - 
  ;;;                 "QUEST"  - 
  ;;;Button1$ -   1
  ;;;Button2$ -   2
  (vl-load-com)
  (if (= ICON$ "")(setq ICON$ "none"))
  (setq MSG$ (str-str-lst MSG$ "\n"))
  ;;;    20 
  (setq i 0)
  (setq MSG$ (vl-remove-if-not '(lambda(x)(< (setq i (1+ i)) 20)) MSG$))
  (setq maxlen (apply 'max (mapcar 'strlen MSG$)))
  (setq tmp nil i 0)
  (setq fl (vl-filename-mktemp "mip.dcl"))
  (setq ret (open fl "w"))
  (repeat (length MSG$)
			(setq tmp
			  (append tmp
			    (list
			      ": text {"
			      (strcat "key = \"msg" (itoa i) "\";")
			         "label = \"\";"
                                 (cond ((< maxlen 11)"width = 12.609;")
                                       ((< maxlen 21)"width = 20;")
                                       ((< maxlen 31)"width = 30;")
                                       ((< maxlen 41)"width = 40;")
                                       ((< maxlen 51)"width = 50;")
                                       ((< maxlen 61)"width = 65;")
                                       ((< maxlen 71)"width = 75;")
                                       ((< maxlen 81)"width = 85;")
                                       (t "width = 15;")
                                       )
			         "fixed_width = true;"
			         "vertical_margin = none;"
			        "}"
			      )))
			(setq i (1+ i))
			)
  (mapcar '(lambda (x) (write-line x ret))
	   (append
            (list "dcl_settings : default_dcl_settings { audit_level = 3; } "
		  "MIPTemp : dialog {"
		  "key = \"title\";"
		  "label = \"\";"
		  ": row {"
		      ": column {"
		        "fixed_width = true;"
		        ": row {"
		        ": column {"
		          " spacer;"
		           ": image {"
		              "key = \"mip_image\";"
		              "width = 5.42;"
		              "height = 2.51;"
		              "fixed_width = true;"
		              "fixed_height = true;"
		              "aspect_ratio = 1;"
		              "color = -15;"
		            "}"
		            "spacer;"
		          "}"
		        ": column {"
		            "spacer;")
	    
		      tmp
	    (list "spacer;"
		        "}"
		       " }"
		     " }"
		  "spacer;"
		  "}"
		  ": row {"
		    "fixed_width = true;"
		    "alignment = centered;"
		     ": button {"
		     "is_default = true;"
		      "key = \"OK\";"
		      (strcat "label = \"" Button1$ "\";")
		  "}"
		  ": button {"
		  "is_cancel = true;"
		  "key = \"Cancel\";"
		  (strcat "label = \"" Button2$ "\";")
		  "}"
		  "}"
		  "}"
		  )
	    )
	  )
	    
    (setq ret (close ret))
  (setq DCL_ID% (load_dialog fl))
    (if (not (new_dialog "MIPTemp" DCL_ID%))
    (exit)
  ) ;_ end of if

  (if (= TITLE$ "")(setq TITLE$ "AutoCAD Message")) ;_ end of if
    (set_tile "title" (strcat " " TITLE$))

  (setq i 0)
  (repeat (length MSG$)
    (set_tile (strcat "msg" (itoa i))(nth i MSG$))
    (setq i (1+ i))
    )
    (if (/= ICON$ "none")
    (eval (read (strcat "(" ICON$ ":)")))
  ) ;_ end of if
   (action_tile "OK" "(done_dialog 1)")
   (action_tile "Cancel" "(done_dialog 2)")
   (setq CHOICE# (start_dialog))
   (unload_dialog DCL_ID%)
  (vl-file-delete fl)
   (if (= CHOICE# 1)
	   BUTTON1$
	   BUTTON2$
    ) ;_ end of if
  )
(defun EXCLAM: ()
  (start_image "mip_image")
  (VECTOR_LINE
    (list "C" 2	  2   25  2   28  3   29  3   23  "C" 2	  4   21  4   29  5   29
	  5   19  "C" 2	  6   17  6   29  7   29  7   15  "C" 2	  8   13  8   29
	  9   29  9   11  "C" 2	  10  9	  10  29  11  29  11  7	  "C" 2	  12  5
	  12  29  13  29  13  18  "C" 2	  13  3	  13  9	  14  9	  14  2	  15  2
	  15  9	  16  9	  16  3	  17  4	  17  9	  "C" 2	  14  21  14  22  16  22
	  16  21  17  22  17  18  "C" 2	  14  27  14  29  15  29  15  27  16  27
	  16  29  17  29  17  27  "C" 2	  18  6	  18  29  19  29  19  8	  "C" 2
	  20  10  20  29  21  29  21  12  "C" 2	  22  14  22  29  23  29  23  16
	  "C" 2	  24  18  24  29  25  29  25  20  "C" 2	  26  22  26  29  27  28
	  27  24  "C" 2	  28  27  28  26
	 ) ;_ end of list
  ) ;_ end of vector_line
  (VECTOR_LINE
    (list "C" 54  3   30  1   28  1   25  2   24  2   23  3   22  3   21  4   20
	  4   19  5   18  5   17  6   16  6   15  7   14  7   13  8   12  8   11
	  9   10  9   9	  10  8	  10  7	  11  6	  11  5	  12  4	  12  3	  14  1
	  16  1	  "C" 54  13  16  13  16  "C" 54  14  19  14  19  "C" 54  16  19
	  16  19  "C" 54  17  16  17  16
	 ) ;_ end of list
  ) ;_ end of vector_line
  (VECTOR_LINE
    (list "C" 9	  13  10  13  10  "C" 9	  17  10  17  10  "C" 9	  13  17  13  17
	  "C" 9	  17  17  17  17  "C" 9	  14  20  14  20  "C" 9	  16  20  16  20
	  "C" 9	  14  23  14  23  "C" 9	  17  23  17  23  "C" 9	  14  26  14  26
	  "C" 9	  17  26  17  26  "C" 9	  16  2	  17  3	  "C" 9	  18  5	  18  5
	  "C" 9	  19  7	  19  7	  "C" 9	  20  9	  20  9	  "C" 9	  21  11  21  11
	  "C" 9	  22  13  22  13  "C" 9	  23  15  23  15  "C" 9	  24  17  24  17
	  "C" 9	  25  19  25  19  "C" 9	  26  21  26  21  "C" 9	  27  23  27  23
	  "C" 9	  28  25  28  25  "C" 9	  28  28  27  29
	 ) ;_ end of list
  ) ;_ end of vector_line
  (VECTOR_LINE
    (list "C" 250 13  15  13  11  14  10  14  18  "C" 250 15  21  15  10  16  10
	  16  18  "C" 250 17  11  17  15  "C" 250 14  25  14  24  15  23  15  26
	  16  26  16  23  17  24  17  25  "C" 250 4   30  27  30  29  28  29  25
	  28  24  28  23  27  22  27  21  26  20  26  19  25  18  25  17  24  16
	  24  15  23  14  23  13  22  12  22  11  21  10  21  9	  20  8	  20  7
	  19  6	  19  5	  18  4	  18  3	  17  2
	 ) ;_ end of list
  ) ;_ end of vector_line
  (VECTOR_LINE
    (list "C" 8	  32  27  32  30  30  32  6   32  5   31  30  31  31  30  31  25
	  30  25  30  30  28  30  29  29  "C" 8	  19  3	  19  4	  20  4	  20  6
	  21  5	  21  8	  22  7	  22  10  23  9	  23  12  24  11  24  14  25  13
	  25  16  26  15  26  18  27  17  27  20  28  19  28  22  29  21  29  24
	  30  23  30  24
	 ) ;_ end of list
  ) ;_ end of vector_line
  (end_image)
) ;_ end of defun
|;


  ;|
* - str-str-lst
*  -    , 
*      
*   
*  [Type]:
  str -    [STRING]
  pat -  [STRING]
*   
  (setq str ";;" pat ";")
  (setq str "    " pat "  ")
  (str-str-lst str pat)
*   http://www.caduser.ru/cgi-bin/f1/board.cgi?t=25113OT
|;
(defun str-str-lst (str pat / i)
  (cond ((= str "") nil)
        ((setq i (vl-string-search pat str))
         (cons (substr str 1 i)
               (str-str-lst (substr str (+ (strlen pat) 1 i)) pat)
         ) ;_  cons
        )
        (t (list str))
  ) ;_  cond
) ;_  defun

(defun bg:layer-status-restore ()
    (foreach item *PD_LAYER_LST*
      (if (not (vlax-erased-p (car item)))
        (vl-catch-all-apply
          '(lambda ()
             (vla-put-lock (car item) (cdr (assoc "lock" (cdr item))))
             (vla-put-freeze (car item) (cdr (assoc "freeze" (cdr item))))
             ) ;_ end of lambda
          ) ;_ end of vl-catch-all-apply
        ) ;_ end of if
      ) ;_ end of foreach
    (setq *PD_LAYER_LST* nil)
    ) ;_ end of defun

  (defun bg:layer-status-save ()
    (setq *PD_LAYER_LST* nil)
    (vlax-for item (vla-get-layers (vla-get-activedocument (vlax-get-acad-object)))
      (setq *PD_LAYER_LST* (cons (list item
                                  (cons "freeze" (vla-get-freeze item))
                                  (cons "lock" (vla-get-lock item))
                                  ) ;_ end of cons
                            *PD_LAYER_LST*
                            ) ;_ end of cons
            ) ;_ end of setq
      (vla-put-lock item :vlax-false)
      (if (= (vla-get-freeze item) :vlax-true)
      (vl-catch-all-apply '(lambda () (vla-put-freeze item :vlax-false))))
      ) ;_ end of vlax-for
    ) ;_ end of defun
(defun ChangeAllObjectsColor (Doc Color  / txtstr tmp txt count)
  (vlax-for Blk	(vla-get-Blocks Doc)
    (if (= (vla-get-IsXref Blk) :vlax-false)
      (progn
	(setq count 0 txt (strcat "Changed " (vla-get-name Blk)))
	(grtext -1 txt)
      (vlax-for	Obj Blk
	(setq count (1+ count))
	(if (zerop(rem count 10))(grtext -1 (strcat txt " : " (itoa count))))
	(if (and (vlax-write-enabled-p Obj)
		 (vlax-property-available-p Obj 'Color)
	    ) ;_ end of and
	  (vla-put-Color Obj Color)
	) ;_ end of if
	(if (and (vlax-write-enabled-p Obj)
		 (vlax-property-available-p Obj 'TextString)
	    ) ;_ end of and
	  (progn
	    (setq txtstr
		   (if (vlax-method-applicable-p Obj 'FieldCode)
		       (vla-FieldCode Obj)
		       (vlax-get-property Obj 'TextString))
		  )
	    (setq tmp 0)
	    (while (setq tmp (VL-STRING-SEARCH "\\C" txtstr tmp))
	      (setq txtstr
	      (vl-string-subst
		(strcat (substr txtstr (1+ tmp) 2)(itoa Color) ";")
		(substr txtstr (1+ tmp) (- (1+ (VL-STRING-SEARCH ";" txtstr tmp)) tmp))
		txtstr
		tmp)
		    )
	      (setq tmp (+ tmp 3))
	      )
	    (vla-put-Textstring Obj txtstr)
	    )
	) ;_ end of if
	(if (and (vlax-write-enabled-p Obj)
		 (= (vla-get-ObjectName obj) "AcDbBlockReference")
		 (= (vla-get-HasAttributes obj) :vlax-true)
	    ) ;_ end of and
	  (foreach att (vlax-safearray->list
			 (vlax-variant-value (vla-GetAttributes obj))
		       ) ;_ end of vlax-safearray->list
	    (if	(and (vlax-write-enabled-p att)
		     (vlax-property-available-p att 'Color)
		) ;_ end of and
	      (vla-put-Color att Color)
	    ) ;_ end of if
	  ) ;_ end of foreach
	) ;_ end of if
        (if (and (vlax-write-enabled-p Obj)
		  (wcmatch (vla-get-Objectname Obj)  "*Dimension*,AcDb*Leader")
	     ) ;_ end of and
	   (progn
	     (vl-catch-all-apply 'vla-put-ExtensionLineColor (list Obj Color))
	     (vl-catch-all-apply 'vla-put-TextColor (list Obj Color))
	     (vl-catch-all-apply 'vla-put-DimensionLineColor (list Obj Color))
	     (if (vlax-property-available-p Obj 'LeaderLineColor)
	       (progn
		 (setq tmp (vla-getinterfaceobject(vlax-get-acad-object)(strcat "AutoCAD.AcCmColor."
		(substr (getvar "ACADVER") 1 2))))
		 (vla-put-colorindex  tmp  Color)
		 (vl-catch-all-apply 'vla-put-LeaderLineColor (list Obj tmp))
		 )
	       )
	   ) ;_ end of progn
	 ) ;_ end of if
      ) ;_ end of vlax-for
      )
    ) ;_ end of if
  ) ;_ end of vlax-for
 (vl-cmdf "_regenall")
) ;_ end of defun


(defun C:BGCOLOR ( / doc col)
  (vl-load-com)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark doc)
  (bg:layer-status-save)
  (if (setq col (acad_colordlg 256))
    (progn
      (ChangeAllObjectsColor doc  col);_ 7   
      ;;;(ChangeXrefAllObjectsColor doc  col)
      )
    )
  ;;;  
  (vl-catch-all-apply
    '(lambda ()
       (entmod
         (mapcar '(lambda (x / y)
                    (if (= (car x) 350)
                      (progn
                        (setq y (mapcar '(lambda (z)
                                           (if (= (car z) 62)
                                             (cons 62 col)
                                             z
                                           ) ;_ end of if
                                         ) ;_ end of lambda
                                        (entget (cdr x))
                                ) ;_ end of mapcar
                        ) ;_ end of setq
                        (cons 350 (entmakex y))
                      ) ;_ end of progn
                      x
                    ) ;_ end of if
                  ) ;_ end of lambda
                 (dictsearch (namedobjdict) "ACAD_MLINESTYLE")
         ) ;_ end of mapcar
       ) ;_ end of entmod
     ) ;_ end of lambda
  ) ;_ end of vl-catch-all-apply
  (bg:layer-status-restore)
  (vla-regen doc acallviewports)
  (vla-endundomark doc)
  (princ)
  )
;;; Returns the list of names of blocks with 1 primitive thing 
;;;      1  ( A$C*   ,  
;;;      - 

(defun bg:block-list-one-item ( / Doc Blks blkname)
  (setq Doc (vla-get-activedocument (vlax-get-acad-object))
	Blks (vla-get-Blocks Doc)
	)
  (vlax-for Blk Blks
    (if (and (= (vla-get-IsXref Blk) :vlax-false)
	  (= (vla-get-IsLayout Blk) :vlax-false)
	  (= (vla-get-count Blk) 1)
;;;   "A$C*"     
	  (or (wcmatch (vla-get-name Blk) "A$C*")
	      (= (vla-get-ObjectName (vla-item Blk 0)) "AcDbBlockReference")
	      )
          ;_ (= (vla-get-ObjectName (vla-item Blk 0)) "AcDbAttributeDefinition")
	  )
      (setq blkname (cons (vla-get-Name Blk) blkname))
      )
    )
    blkname
  )

(defun bg:block-GetXclip ( vla-obj / result )
;;; LISP  vla
;;;  (and (setq blk (car(entsel "\n  ")))
;;;     (setq dict (cdr(assoc 360 (entget blk))))
;;;     (if (and
;;;           (setq sp (member '(3 . "ACAD_FILTER") (entget dict)))
;;;           (setq sp (cdr(assoc 360 sp)))
;;;           (setq sp (member '(3 . "SPATIAL")(entget sp)))
;;;           (setq sp (cdr(assoc 360 sp)))
;;;           )
;;;       (progn
;;;         (if (= (cdr(assoc 71 (entget sp))) 1)
;;;           (alert " \n ")
;;;           (alert " \n ")
;;;         )
;;;         )
;;;       (alert "  ")
;;;         )
;;;     )
;;  ,  SPATIAL,  nil
;;If the block is clipped, returns SPATIAL filter, differently return nil
;; test
;; (bg:block-GetXclip (vlax-ename->vla-object(car(entsel "\nSelect clipped xref"))))
  
   (vl-catch-all-apply
      '(lambda ( )
           (if
               (and
		 (eq (vla-get-ObjectName vla-obj) "AcDbBlockReference")
                   (eq :vlax-true
                       (vla-get-HasExtensionDictionary vla-obj)
                   )
               )
               (setq result
                   (entget
                       (vlax-vla-object->ename
                           (vla-item
                               (vla-item
                                   (vla-getExtensiondictionary vla-obj)
                                   "ACAD_FILTER"
                               )
                               "SPATIAL"
                           )
                       )
                   )
               )
           )
       )
   )

   result
)
(defun bg:block-get-name (blkobj)
(cond
  ((and (vlax-property-available-p blkobj 'isdynamicblock)
	(= (vla-get-isdynamicblock blkobj) :vlax-true)
	) ;_ end of and
   (vla-get-effectivename blkobj)
   )
  (t (vla-get-name blkobj))
  ) ;_ end of cond
  )
;;;  ,    
;;; Explode blocks consisting of one primitive thing (it is possible other block)
(defun bg:block-explode-one-item ( / blklist count xcount tmp)
   (bg:layer-status-save)
  (setq blklist (bg:block-list-one-item) count 0 xcount 0)
  (vlax-for obj (vla-get-block(vla-item (vla-get-Layouts(vla-get-activedocument (vlax-get-acad-object)))(getvar "CTAB")))
    (if (and (eq (vla-get-ObjectName obj) "AcDbBlockReference")
	     (not (vlax-property-available-p obj 'path))
	     (vl-position (bg:block-get-name obj) blklist)
        )
      (progn
	(if (and (setq tmp (bg:block-GetXclip obj))
		 (= 1 (cdr(assoc 71 tmp)))
		 )
	  (progn
	    ;;;       
	    ;;; 
	    (setq xcount (1+ xcount))
	    )
	 (progn
	   (bg:explode-block (vlax-vla-object->ename obj) nil)
	   (setq count (1+ count))
	   )
	)
      )
      )
    )
  (bg:layer-status-restore)
  (list count xcount)
  )

;;en -ename
;;Rdn - string name of appid or nil -all
;;    ( XDATA  )
(defun bg:del-XDATA-from-ename (en Rdn / elist sub)
  (if (= (type en) 'vla-object)
    (setq en (vlax-vla-object->ename en))
  )
  (setq elist (entget en (list "*")))
  (if (null Rdn)
    (progn
      (setq sub (mapcar 'car (cdr (assoc -3 elist))))
      (setq sub	(vl-remove-if
		  '(lambda (x) (wcmatch (strcase x) "ACAD*,ACDB*"))
		  sub
		)
      )
      (if sub
	(progn
	  (setq sub (list (cons -3 (mapcar 'list sub))))
	  (entmod (append (entget en) sub))
	)
      )
    )
    (progn
      (foreach i (cdr (assoc -3 elist))
	(if (not (wcmatch (strcase (car i)) (strcase Rdn)))
	  (setq sub (append sub (list i)))
	  (setq sub (append sub (list (list (car i)))))
	)
      )
      (setq sub	  (cons -3 sub)
	    elist (subst sub (assoc -3 elist) elist)
	    elist (entmod elist)
      )
    )
  )
)

(defun c:BGBLCC () (bg:block-color) (princ))
(defun c:BGENCC () (pl:block-ent-color) (princ))
;;; Alaspher encc http://forum.dwg.ru/showthread.php?t=1036
;;; http://forum.dwg.ru/showpost.php?p=166220&postcount=18
(defun pl:block-ent-color (/ adoc blocks color ent lays)
    (setq adoc  (vla-get-activedocument (vlax-get-acad-object))
          lays  (vla-get-layers adoc)
          color (acad_colordlg 256)
    )
    (if color
        (progn (setvar "errno" 0)
               (vla-startundomark adoc)
               (while (and (not (vl-catch-all-error-p
                                    (setq ent (vl-catch-all-apply
                                                  (function nentsel)
                                                  '("\nSelect entity <Exit>:")
                                              )
                                    )
                                )
                           )
                           (/= 52 (getvar "errno"))
                      )
                   (if ent
                       (progn (setq ent (vlax-ename->vla-object (car ent))
                                    lay (vla-item lays (vla-get-layer ent))
                              )
                              (if (= (vla-get-lock lay) :vlax-true)
                                  (progn (setq layloc (cons lay layloc))
                                         (vla-put-lock lay :vlax-false)
                                  )
                              )
                              (vl-catch-all-apply (function vla-put-color) (list ent color))
                              (vla-regen adoc acallviewports)
                       )
                       (princ "\nNothing selection! Try again.")
                   )
               )
               (foreach i layloc (vla-put-lock i :vlax-true))
               (vla-endundomark adoc)
        )
    )
    (princ)
)
;;;  Alaspher blcc encc http://forum.dwg.ru/showthread.php?t=1036
(defun bg:block-color (/ adoc blocks color ins lays ss e2)
    (setq adoc   (vla-get-activedocument (vlax-get-acad-object))
          blocks (vla-get-blocks adoc)
          lays   (vla-get-layers adoc)
          color  (acad_colordlg 256)
    )
    (if color
        (progn (setvar "errno" 0)
               (vla-startundomark adoc)
               (while (and (not (vl-catch-all-error-p
                                    (setq ins (vl-catch-all-apply
                                                  (function entsel)
                                                    (list (if (= (getvar "DWGCODEPAGE") "ANSI_1251")
                                                            "\n  <>:"
                                                            "\nSelect block <Exit>:")
                                                          )
                                              )
                                    )
                                )
                           )
                           (/= 52 (getvar "errno"))
                      )
                   (if ins
                       (progn (setq ss nil ss (cdr(assoc 2 (entget(car ins)))))
			      (setq ins (vlax-ename->vla-object (car ins)))
                              (if (= (vla-get-objectname ins) "AcDbBlockReference")
                                  (if (vlax-property-available-p ins 'path)
                                      (princ "\nThis is external reference! Try pick other.")
                                      (progn
					(bg:layer-status-save)
					(_pl:block-color blocks ins color lays)
					(if (setq ss (ssget "_X" (list (cons 2 ss)(cons 66 1)(cons 410 (getvar "CTAB")))))
					  (progn
					    (foreach blk (mapcar (function vlax-ename->vla-object) (vl-remove-if (function listp)
							  (mapcar (function cadr) (ssnamex ss))))
					      (foreach at (vlax-invoke blk 'Getattributes)
						(vl-catch-all-apply (function vla-put-color)(list at color))
						)
					      )
					    )
					  )
					     (bg:layer-status-restore)
                                             (vla-regen adoc acallviewports)
                                      )
                                  )
                                  (princ "\nThis isn't block! Try pick other.")
                              )
                       )
                       (princ "\nNothing selection! Try again.")
                   )
               )
               (vla-endundomark adoc)
        )
    )
    (princ)
)

(defun _pl:block-color (blocks ins color lays / lay layfrz layloc)
    (vlax-for e (vla-item blocks (vla-get-name ins))
        (setq lay (vla-item lays (vla-get-layer e)))
        (if (= (vla-get-freeze lay) :vlax-true)
            (progn (setq layfrz (cons lay layfrz)) (vla-put-freeze lay :vlax-false))
        )
        (if (= (vla-get-lock lay) :vlax-true)
            (progn (setq layloc (cons lay layloc)) (vla-put-lock lay :vlax-false))
        )
        (vl-catch-all-apply (function vla-put-color) (list e color))
        (if (and (= (vla-get-objectname e) "AcDbBlockReference")
                 (not (vlax-property-available-p e 'path))
            )
            (_pl:block-color blocks e color lays)
        )
        (foreach i layfrz (vla-put-freeze i :vlax-true))
        (foreach i layloc (vla-put-lock i :vlax-true))
    )
)

(defun bg:DetachImage (ImgName)
        (vl-catch-all-apply
            '(lambda ()
                 (vla-delete
                     (vla-item
                         (vla-item
                             (vla-get-dictionaries
                                 (vla-get-activedocument (vlax-get-acad-object))
                             ) ;_ end of vla-get-dictionaries
                             "ACAD_IMAGE_DICT"
                         ) ;_ end of vla-Item
                         ImgName
                     ) ;_ end of vla-Item
                 ) ;_ end of vla-Delete
             ) ;_ end of lambda
        ) ;_ end of vl-catch-all-apply
    ) ;_ end of defun

;;;      
(defun bg:delete-from-layer (/			 layer-list
			     aDOC		 count
			     *error*		 all_raster_image_name
			     used_raster_image_name
			     ignore-block-list
			    )
  ;;;      
  (defun *error* (msg)
    (setvar "MODEMACRO" "")
    (princ msg)
    (vla-regen aDOC acactiveviewport)
    (bg:progress-clear)
    (princ)
  ) ;_ end of defun
  (defun _loc-delete-items ()
    (if	(= (vla-get-IsXref Blk) :vlax-false)
      (progn
	(setq count 0)
	(if (> (vla-get-count Blk) 100)
	  (bg:progress-init
	    (strcat (vla-get-name Blk) " :")
	    (vla-get-count Blk)
	  ) ;_ end of bg:progress-init
	  (progn
	    (setvar "MODEMACRO" (vla-get-name Blk))
	  ) ;_ end of progn
	) ;_ end of if
	(vlax-for Obj Blk
	  (if (and
		(= (vla-get-ObjectName Obj) "AcDbRasterImage")
		(vlax-property-available-p obj 'Name)
		(not (vl-catch-all-error-p
		       (vl-catch-all-apply 'vla-get-name (list obj))
		     ) ;_ end of vl-catch-all-error-p
		) ;_ end of not
		(vlax-property-available-p obj 'ImageFile)
	      ) ;_ end of and
	    (setq used_raster_image_name
		   (cons (vla-get-Name Obj)
			 used_raster_image_name
		   ) ;_ end of cons
	    ) ;_ end of setq
	  ) ;_ end of if
;;;       0    
	  (if (or
		(eq (vla-get-IsLayout Blk) :vlax-true)
		(and (eq (vla-get-IsLayout Blk) :vlax-false)
		     (= (vla-get-ObjectName Blk) "AcDbBlockTableRecord")
		     (/= (vla-get-layer Obj) "0")
		) ;_ end of and
	      ) ;_ end of or
	    (vl-catch-all-apply
	      '(lambda ()
		 (bg:progress (setq count (1+ count)))
		 (if (vlax-write-enabled-p Obj)
		   (if
		     (and (vlax-property-available-p Obj 'Layer)
			  (vl-position (vla-get-layer Obj) layer-list)
		     ) ;_ end of and
						  ;ObjectName (RO) = "AcDbBlockReference"
						  ;ObjectName (RO) = "AcDbBlockTableRecord"
		      (if (= (vla-get-ObjectName Obj)
			     "AcDbBlockReference"
			  ) ;_ end of =
			(if (not (vl-position
				   (vla-get-name Obj)
				   ignore-block-list
				 ) ;_ end of vl-position
			    ) ;_ end of not
			  (vl-catch-all-apply 'vla-delete (list Obj)) ;_ Delete BlockReference object
			) ;_ end of if
			(vl-catch-all-apply 'vla-delete (list Obj)) ;_ Delete OTHER object
		      ) ;_ end of if
		      (vl-catch-all-apply
			'bg:del-XDATA-from-ename
			(list Obj nil)
		      ) ;_Delete Appid from Object
		   ) ;_ end of if
		 ) ;_ end of if
	       ) ;_ end of lambda
	    ) ;_ end of vl-catch-all-apply
	  ) ;_ end of if
	) ;_ end of vlax-for
	(bg:progress-clear)
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of defun
  (setq	layer-list nil
	aDOC	   (vla-get-activedocument (vlax-get-acad-object))
  ) ;_ end of setq
;;;  (grtext -1 "Stage 1. Viewing of layers")
  (vlax-for item (vla-get-layers aDOC)
    (if	(or (= (vla-get-freeze item) :vlax-true)
	    (= (vla-get-layeron item) :vlax-false)
	) ;_ end of or
      (setq layer-list (cons (vla-get-name item) layer-list))
    ) ;_ end of if
  ) ;_ end of vlax-for
  (bg:layer-status-save)
  (setq layer-list (vl-remove-if-not 'snvalid layer-list))
;;;  (grtext -1 "Stage 1. Viewing of layers")
  (if layer-list
    (progn
      (setq ignore-block-list nil)
      (vlax-for	Blk (vla-get-Blocks aDOC)
;;;2 :      
;;; ignore-block-list -  
;;;        
	(if (eq (vla-get-IsLayout Blk) :vlax-false) ;_ 1-   
	  (progn
	    (_loc-delete-items)
	    (setq count nil)
	    (vlax-for Obj Blk
	      (if
		(and (/= (vla-get-layer Obj) "0")
		     (not (vl-position (vla-get-layer Obj) layer-list))
		) ;_ end of and
		 (setq ignore-block-list
			(cons (vla-get-Name Blk)
			      ignore-block-list
			) ;_ end of cons
		 ) ;_ end of setq
	      ) ;_ end of if
	    ) ;_ end of vlax-for

	  ) ;_ end of progn
	) ;_ end of if
      ) ;_ end of vlax-for
;;;2 :      
      (vlax-for	Blk (vla-get-Blocks aDOC)
;;; ignore-block-list -  
;;;        
	(if (eq (vla-get-IsLayout Blk) :vlax-true)
	  (_loc-delete-items)
	) ;_ end of if
      ) ;_ end of vlax-for
    ) ;_ end of progn
  ) ;_ end of if
;;;  (grtext -1 "Stage 3. Audit and Purge")
  (vla-auditinfo aDOC :vlax-true)
;;;Audit
  (repeat 3 (vla-purgeall aDOC))
  (if
    (setq all_raster_image_name
	   (mapcar 'cdr
		   (vl-remove-if-not
		     (function (lambda (x) (= 3 (car x))))
		     (dictsearch (namedobjdict) "ACAD_IMAGE_DICT")
		   ) ;_ end of vl-remove-if-not
	   ) ;_ end of mapcar
    ) ;_ end of setq
     (setq all_raster_image_name (mapcar 'strcase all_raster_image_name))
  ) ;_ end of if
  (setq used_raster_image_name (mapcar 'strcase used_raster_image_name))
  (mapcar
    '(lambda (img)
       (setq all_raster_image_name
	      (vl-remove img all_raster_image_name)
       ) ;_ end of setq
     ) ;_ end of lambda
    used_raster_image_name
  ) ;_ end of mapcar
  (mapcar 'bg:DetachImage all_raster_image_name)

;;;  ???????
;;;  (vl-cmdf "_.Redrawall")
    (vla-regen aDOC acActiveViewport)

  (setq *PD_LAYER_LST* nil)
) ;_ end of defun
(defun bg:conv-to-str (dat)
  (cond ((= (type dat) 'INT)(setq dat (itoa dat)))
         ((= (type dat) 'REAL)(setq dat (rtos dat 2 12)))
        ((null dat)(setq dat ""))
        (t (setq dat (vl-princ-to-string dat)))))  
;;;********* -   BURST.LSP ************
;;;  Express  !!!
(Defun ITEM (N E) (CDR (Assoc N E)))
;;;(acet-error-init (list (list "cmdecho" 0
;;;"highlight" 1) T))
(Defun BITSET (A B) (= (Boole 1 A B) B))
(Defun bump (prmpt)(terpri)(Princ prmpt))
(Defun ATT-TEXT (AENT / TENT ILIST INUM)
(Setq TENT '((0 . "TEXT")))
(ForEach INUM '(8 6 38 39 62 67 210 10 40 1 50 41 51 7 71 72 73 11 74)
(If (Setq ILIST (Assoc INUM AENT))(Setq TENT (Cons ILIST TENT))))
(Setq tent (Subst (Cons 73 (item 74 aent))(Assoc 74 tent) tent))
(EntMake (Reverse TENT)))
(Defun LASTENT (/ E0 EN)(Setq E0 (EntLast))
(While (Setq EN (EntNext E0))(Setq E0 EN)) E0)
   ;-----------------------------------------------------
   ; See if a block is explodable. Return T if it is, 
   ; otherwise return nil
   ;-----------------------------------------------------
 
   (Defun EXPLODABLE (BNAME / B expld)
      (setq BLOCKS (vla-get-blocks 
                     (vla-get-ActiveDocument (vlax-get-acad-object)))
       )
      
      (vlax-for B BLOCKS (if (and (= :vlax-false (vla-get-islayout B))
                                  (= (strcase (vla-get-name B)) (strcase BNAME))
                                  )
                           (if (vlax-property-available-p B "explodable")  ;;; VVA Correct to 2004 AutoCAD
                             (setq expld (= :vlax-true (vla-get-explodable B)))  
                             (setq expld t)
                             )
                           )
           )
       expld
    )

(defun bg:del-from-list ( pat lst / tmp )
  (foreach item lst
    (if (/= (car item) pat)
      (setq tmp (cons item tmp))
      )
    )
    (reverse tmp)
  )
(Defun BURST-ONE (BNAME	   /	BBLOCK    BENT     ANAME    ENT      ATYPE
		  AENT	   AGAIN    ENAME    ENT      SS-COLOR SS-LAYER
		  SS-LTYPE SS-LWEIGHT  mirror   ss-mirror TMP mlast BLAYER  BCOLOR BLTYPE BLWEIGHT
                  attlist
		 )
  (Setq	BENT   (EntGet BNAME)
	BLAYER (ITEM 8 BENT)
	BCOLOR (ITEM 62 BENT)
	BBLOCK (ITEM 2 BENT)
	BCOLOR (Cond ((> BCOLOR 0) BCOLOR)
		     ((= BCOLOR 0) "BYBLOCK")
		     ("BYLAYER")
	       )
	BLTYPE (Cond ((ITEM 6 BENT))
		     ("BYLAYER")
	       )
	BLWEIGHT (Cond ((not (ITEM 370 BENT)) "BYLAYER") ;_Add VVA BURST LWEIGHT SECTION
		     ((minusp (ITEM 370 BENT)) "_D")     ;_Default ;_Add VVA BURST LWEIGHT SECTION
		     ((ITEM 370 BENT))                   ;_Add VVA BURST LWEIGHT SECTION
		     ("BYLAYER")                         ;_Add VVA BURST LWEIGHT SECTION
	         )                                       ;_Add VVA BURST LWEIGHT SECTION
  )
  (Setq ELAST (LASTENT))
  (If (and (EXPLODABLE BBLOCK)(= 1 (ITEM 66 BENT)))
    (Progn (Setq ANAME BNAME)
	   (While (Setq	ANAME (EntNext ANAME)
			AENT  (EntGet ANAME)
			ATYPE (ITEM 0 AENT)
			AGAIN (= "ATTRIB" ATYPE)
		  )
	     (bump "Converting attributes")
;;;-> VVA 30.07.2008
	     (if (or
                     (zerop (logand (cdr (assoc 70 AENT)) 1)) ;_Change by VVA Attr fix 03.09.2008 Not hidden attribute
                     (zerop (logand (cdr (assoc 70 AENT)) 9)) ;_Add kakt00z 1.06.2010 ( http://forum.dwg.ru/showpost.php?p=580531&postcount=33 )
                     )
	       (progn
		  (setq tmp (cdr (assoc 2 AENT)))           ;_ add VVA 20.03.2009
	          (ATT-TEXT AENT)                           ;_Change by VVA Attr fix 03.09.2008
		  (setq attlist (cons (list tmp (entlast)) attlist)) ;_ add VVA 20.03.2009
		  )
	     )
	   )
    )
  )
;;;<- VVA 30.07.2008

  (Progn (bump "Exploding block") (acet-explode BNAME))
  (Setq	SS-LAYER (SsAdd)
	SS-COLOR (SsAdd)
	SS-LTYPE (SsAdd)
	SS-LWEIGHT (SsAdd)    ;_Add VVA BURST LWEIGHT SECTION
	ENAME	 ELAST
  )
  (bump "Gathering pieces")
  (While (Setq ENAME (EntNext ENAME))
    (Setq ENT	(EntGet ENAME)
	  ETYPE	(ITEM 0 ENT)
    )
    (If	(= "ATTDEF" ETYPE)
      (Progn
	(setq tmp (cdr(assoc 2 ENT)))                             ;_ add VVA 20.03.2009
        (setq attlist (bg:del-from-list tmp attlist))   ;_ add VVA 13.07.2010
;;;               (If (BITSET (ITEM 70 ENT) 2)   ;_Rem by VVA Attr fix   03.09.2008
;;;                  (ATT-TEXT ENT)              ;_Rem by VVA Attr fix   03.09.2008
;;;               )                              ;_Rem by VVA Attr fix   03.09.2008
        (EntDel ENAME)
       )
      (if (not(member (strcase ETYPE) '("ATTRIB" "SEQEND"))) ;;; Change VVA 12.09.2008
      (Progn (If (= "0" (ITEM 8 ENT))
	       (SsAdd ENAME SS-LAYER)
	     )
	     (If (= 0 (ITEM 62 ENT))    ;_ -> START Change VVA BURST
	       (if (= "0" (ITEM 8 ENT))
		 (SsAdd ENAME SS-COLOR)
		 (progn
		   (if (null (ITEM 62 BENT)) ;_Block color type bylayer
		    (Command "_.chprop" ENAME "" "_C" (ITEM 62 (entget (TBLOBJNAME "LAYER" BLAYER))) "")
		    (SsAdd ENAME SS-COLOR) 
		     )
		   )
		 )                     ;_ <- END Change VVA BURST
	     )
	     (If (= "BYBLOCK" (strcase (cond ((ITEM 6 ENT))("")))) ;_ -> START Change VVA BURST
	       (if (= "0" (ITEM 8 ENT))
		 (SsAdd ENAME SS-LTYPE)
		 (progn
		   (if (= "BYLAYER" (strcase (cond ((ITEM 6 BENT))("BYLAYER")))) ;_Block line type bylayer
		    (Command "_.chprop" ENAME "" "_LT" (ITEM 6 (entget (TBLOBJNAME "LAYER" BLAYER))) "")
		    (SsAdd ENAME SS-LTYPE) 
		     )
		   )
		 )
	     )                                                     ;_ <- END Change VVA BURST
	;_ -> START Change VVA BURST LWEIGHT SECTION
	(If (= -2 (ITEM 370 ENT)) ;_ -> BYBLOCK LWEIGHT
	       (if (= "0" (ITEM 8 ENT))
		 (SsAdd ENAME SS-LWEIGHT)
		 (progn
		   (if (NOT (ITEM 370 BENT)) ;_Block LWEIGHT BYLAYER
		    (Command "_.chprop" ENAME "" "_LW"
			     (if (minusp (setq TMP (ITEM 370 (entget (TBLOBJNAME "LAYER" BLAYER)))))
			       "_D"
			       (* TMP 0.01))
				   "")
		    (SsAdd ENAME SS-LWEIGHT) 
		     )
		   )
		 )
	     )
	;_ <- END Change VVA BURST LWEIGHT SECTION
      )
	)
    )
  )
  (foreach itm attlist                 ;_ add VVA 20.03.2009
       (if itm (progn                     ;_ add VVA 20.03.2009
		 (setq tmp (cadr itm))    ;_ add VVA 20.03.2009
		 (ssdel tmp SS-LAYER)     ;_ add VVA 20.03.2009
		 (ssdel tmp SS-COLOR)     ;_ add VVA 20.03.2009
		 (ssdel tmp SS-LTYPE)     ;_ add VVA 20.03.2009
		 (ssdel tmp SS-LWEIGHT)   ;_ add VVA 20.03.2009
		 (ENTDEL (cadr itm))      ;_ add VVA 20.03.2009
		 )                        ;_ add VVA 20.03.2009
	 )                                ;_ add VVA 20.03.2009
       )                                  ;_ add VVA 20.03.2009
  (If (> (SsLength SS-LAYER) 0)
    (Progn (bump "Fixing layers")
	   (Command "_.chprop" SS-LAYER "" "_LA" BLAYER "")
    )
  )
  (If (> (SsLength SS-COLOR) 0)
    (Progn (bump "Fixing colors")
	   (Command "_.chprop" SS-COLOR "" "_C" BCOLOR "")
    )
  )
  (If (> (SsLength SS-LTYPE) 0)
    (Progn (bump "Fixing linetypes")
	   (Command "_.chprop" SS-LTYPE "" "_LT" BLTYPE "")
    )
  )
  (If (> (SsLength  SS-LWEIGHT) 0)                                 ;_Add VVA BURST LWEIGHT SECTION
    (Progn (bump "Fixing lineweightes")                            ;_Add VVA BURST LWEIGHT SECTION
	   (Command "_.chprop"  SS-LWEIGHT "" "_LW"
		    (if (numberp BLWEIGHT)(* BLWEIGHT 0.01) BLWEIGHT)  "")   ;_Add VVA BURST LWEIGHT SECTION 
    )                                                              ;_Add VVA BURST LWEIGHT SECTION
  )                                                                ;_Add VVA BURST LWEIGHT SECTION
  (setq SS-LAYER nil SS-COLOR nil SS-LTYPE nil SS-LWEIGHT NIL)
)
 ;;;*************** END Burst.lsp *******************************
;;;   
;;; list of nested block
;;; http://www.cadtutor.net/forum/showthread.php?t=48702
 ;;;(defun ContainsNested ( ent / foo )
  ;;  Lee Mac  ~  03.06.10

  ;;;(defun foo ( e )
    ;;;(if (setq e (entnext e))
      ;;;(cons e (foo e))
    ;;;)
  ;;;)

  ;;;(member "INSERT"
    ;;;(mapcar 
      ;;;(function
        ;;;(lambda ( x )
          ;;;(cdr (assoc 0 (entget x)))
        ;;;)
      ;;;)
      ;;;(foo ent)
    ;;;)
  ;;;)
;;;)
 
;;http://forum.dwg.ru/showthread.php?t=8346 (   VLA-SELECT )
;;http://forums.augi.com/showthread.php?p=738077#post738077
;;;-   BURST-
;;;,  - EXPLODE
;;;     nested blocks
;;;     *ssRET*
;;;    
;;; blk - Ename 
;;; level - t all level nil -one level
(defun bg:explode-block-to-ss (blk level / memb name)
(foreach memb (bg:burst-list Blk)
  (setq name (vla-get-ObjectName memb))
  (cond ((and level (= name "AcDbBlockReference"))(bg:explode-block-to-ss (vlax-vla-object->ename memb) level ));_BURST 
;;;	
;;;	((wcmatch (strcase name) "*DIMENSION,*REGION");_   
;;;	 (bg:explode-to-SS (vlax-vla-object->ename memb)))
;;;	
	(t  (ssadd (vlax-vla-object->ename memb) *ssRET*)))))
;_  BURST'      VLA
(defun bg:burst-list (blk / ret sc ec csp ELAST ENAME)
  ;(setq csp (vla-ObjectIDToObject (vla-get-activedocument (vlax-get-acad-object)) (vla-get-OwnerID (vlax-ename->vla-object blk))))
  ;(setq sc (1-(vla-get-count csp)))
  (Setq ELAST (LASTENT))
  (BURST-ONE blk)
  (setq ENAME ELAST ret nil)
  (While (Setq ENAME (EntNext ENAME))
    (setq ret (cons (vlax-ename->vla-object ENAME) ret))
    )
;;;  (setq ec (vla-get-count csp))
;;;  (while (< sc ec)
;;;    (setq memb (vla-item csp sc))
;;;    (setq ret (append ret (list memb)))
;;;    (setq sc(1+ sc)))
  ret)
;_  Expolde     *ssREt*
(defun bg:explode-to-SS (en / sc ec csp)
  (setq csp (vla-ObjectIDToObject (vla-get-activedocument (vlax-get-acad-object)) (vla-get-OwnerID (vlax-vla-object->ename en))))
  (setq sc (1-(vla-get-count csp)))
  (vl-cmdf "_.EXPLODE" en)
  (setq ec (vla-get-count csp))
  (while (< sc ec)
    (setq memb (vla-item csp sc))
    (ssadd (vlax-vla-object->ename memb) *ssRET*)
    (setq sc(1+ sc))))

;;; blk - Ename 
;;; level - t all level nil -one level
(defun bg:explode-block ( blk level / adoc csp blk_obj)
;_   
;_,    
;_   *ssREt*
;_ blk - Ename 
  
;;;  (setq adoc (vla-get-activedocument (vlax-get-acad-object))
;;;	blk_obj (vlax-ename->vla-object blk)
;;;	csp (vla-ObjectIDToObject (vla-get-activedocument (vlax-get-acad-object)) (vla-get-OwnerID blk_obj)))
  (setq *ssRET* nil)
  (if (/= (type *ssRet*) 'PICKSET)(setq *ssRET* (ssadd)))
  (bg:explode-block-to-ss blk level)
*ssRET*)

;;  -      
;;;(defun c:TEST ( / blk blk_obj)
;;;(setq blk (car(entsel "\n ")))
;;;  ;_ 
;;;  (setq *ssRET* nil *ssRET*  (ssadd))
;;;  (bg:explode-block blk t)
;;;  (command "_CHANGE" *ssRET* "" "_P" "_C" 1 "")
;;;  (princ))
;;;
;;published by kpblc
;;http://www.arcada.com.ua/forum/viewtopic.php?t=526
;;modyfied and published by VVA
;;http://www.cadtutor.net/forum/showthread.php?t=13295
;|=============================================================================
*     ""   .     
*    ByBlock    ,   ,  ,
*    (  , ..  ).
*      ,  .
*     
=============================================================================|;
(defun C:BGBLFIX ( / adoc answer *error* ans0 atype cnt isRus ss)
 (defun *error* (msg)(princ msg)(bg:layer-status-restore)(vl-cmdf "_.Redraw"))
  (vl-load-com)(setq cnt 0 isRus (= (getvar "DWGCODEPAGE") "ANSI_1251"))
  (bg:layer-status-save)
  (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark adoc)
  (if isRus
  (initget "    LType LWeight Color All _ T W C A T W C A")
  (initget "LType LWeight Color All _ T W C A")
    )
  (if (null (setq answer
      (getkword
        (if isRus
        "\n   [///] <> : "
        "\nTo normalize in the block [LType/LWeight/Color/All] <All> : "
          ))))
    (setq answer "A")) ;_ end of if
  (if isRus
    (initget "  byLayer byBlock _ byLayer byBlock byLayer byBlock")
    (initget "byLayer byBlock")
    )
  (setq atype (getkword
                (if isRus
                "\n    [/] <>:"
                "\nSet contents inside the block to [byLayer/byBlock] <byBlock>:")))

  (initget "Yes No")
  (setq ans0 (getkword
               (if isRus
               "\n    0? [Yes/No] <No>:"
               "\nChange entities layer's to 0? [Yes/No] <No>:")))
  (vlax-for item (vla-get-blocks adoc)
    (if (and (= (vla-get-IsLayout item) :vlax-false)
             (= (vla-get-IsXRef item) :vlax-false))
      (progn
      (setq cnt (1+ cnt))
      (grtext -1 (strcat (if isRus " " "Modyfied ") (vla-get-name item)))
      ;(print (strcat (if isRus " " "Modyfied ") (vla-get-name item)))
   (vlax-for   sub_item item ;(vla-item (vla-get-blocks adoc) (vla-get-name item))
   (if (= ans0 "Yes")(vla-put-Layer sub_item "0"))
   ;;;   0
;;;   (if (vlax-property-available-p sub_item "ConstantWidth")
;;;   (vl-catch-all-apply
;;;        '(lambda ()
;;;           (vla-put-ConstantWidth sub_item 0.)
;;;           ) ;_ end of lambda
;;;        ) ;_ end of vl-catch-all-apply
;;;     )

   (cond
     ((= answer "W")(vla-put-LineWeight sub_item (if (= atype "byLayer") acLnWtByLayer aclnwtbyblock)))
     ((= answer "T")(vla-put-linetype sub_item (if (= atype "byLayer") "ByLayer" "ByBlock")))
     ((= answer "C")(vla-put-color sub_item (if (= atype "byLayer") acByLayer acByBlock)))
     (t
      (vla-put-LineWeight sub_item (if (= atype "byLayer") acLnWtByLayer aclnwtbyblock))
      (vla-put-linetype sub_item (if (= atype "byLayer") "ByLayer" "ByBlock"))
      (vla-put-color sub_item (if (= atype "byLayer") acByLayer acByBlock))
      )
     ) ;_ end of cond
    (if (and (= (vla-get-objectname sub_item) "AcDbBlockReference")
             (vlax-property-available-p sub_item 'Hasattributes)
             (not(vlax-property-available-p sub_item 'path))
             )
      (foreach at (append (vlax-invoke sub_item 'GETATTRIBUTES)
                                 (vlax-invoke sub_item 'GETCONSTANTATTRIBUTES)
                                 )
           (if (= ans0 "Yes")(vla-put-Layer at "0"))
        (cond
          ((= answer "W")(vla-put-LineWeight at (if (= atype "byLayer") acLnWtByLayer aclnwtbyblock)))
          ((= answer "T")(vla-put-linetype at (if (= atype "byLayer") "ByLayer" "ByBlock")))
          ((= answer "C")(vla-put-color at (if (= atype "byLayer") acByLayer acByBlock)))
          (t (vla-put-LineWeight at (if (= atype "byLayer") acLnWtByLayer aclnwtbyblock))
             (vla-put-linetype at (if (= atype "byLayer") "ByLayer" "ByBlock"))
             (vla-put-color at (if (= atype "byLayer") acByLayer acByBlock))
           )
          ) ;_ end of cond
        )
      )
   ) ;_ end of vlax-for
   )
      ) ;_ end of if
    ) ;_ end of vlax-for
  (if (setq ss (ssget "_X" (list (cons 0 "INSERT")(cons 66 1))))
    (progn
      (foreach blk (mapcar (function vlax-ename->vla-object) (vl-remove-if (function listp)
	  (mapcar (function cadr) (ssnamex ss))))
          (foreach at (vlax-invoke blk 'Getattributes)
	    (if (= ans0 "Yes")(vla-put-Layer at "0"))
            (cond ((= answer "W")(vla-put-LineWeight at (if (= atype "byLayer") acLnWtByLayer aclnwtbyblock)))
                  ((= answer "T")(vla-put-linetype at (if (= atype "byLayer") "ByLayer" "ByBlock")))
                  ((= answer "C")(vla-put-color at (if (= atype "byLayer") acByLayer acByBlock)))
                  (t (vla-put-LineWeight at (if (= atype "byLayer") acLnWtByLayer aclnwtbyblock))
                     (vla-put-linetype at (if (= atype "byLayer") "ByLayer" "ByBlock"))
                     (vla-put-color at (if (= atype "byLayer") acByLayer acByBlock))
                   )
                  ) ;_ end of cond
            )
        )
      )
    )
  (vla-regen adoc acallviewports)
  (vla-endundomark adoc)(vl-cmdf "_.Redraw")
  (bg:layer-status-restore)
  (princ (if isRus
           (strcat "\n " (itoa cnt) " ")
           (strcat "\nModyfied " (itoa cnt) " blocks")
           )
         )
  (princ)
  ) ;_ end of defun

(defun C:BGLAYDEL ()
  ;;;      
  (if
    (if	(= (getvar "DWGCODEPAGE") "ANSI_1251")
      (bg:msg-yes-no
	""
	"    \n   \n    ?"
      )
      (bg:msg-yes-no
	"Attension"
	"You really want to remove \nfrozen and off layers and objects on it?"
      )
    )
     (progn
       (command "_.UNDO" "_Mark")
       (setvar "CLAYER" "0")
       (bg:delete-from-layer)
       (command "_.Regenall")
       (princ "\n*** Command _.UNDO _Back restore your layers")
       (princ)
     )
  )
  (princ)
)
;;;BG Color ATTribute
(defun C:BGCATT ( / ss i obj color *error* adoc)
   (defun *error* (msg)
     (setvar "NOMUTT" 0)
     (princ msg)
     (bg:layer-status-restore)
     (vla-endundomark adoc)(princ))
  (setq adoc  (vla-get-activedocument (vlax-get-acad-object))
   i '-1)
  (vla-startundomark adoc)
   (if (and (setq color (acad_colordlg 256))
            (setvar "NOMUTT" 1)
            (if (= (getvar "DWGCODEPAGE") "ANSI_1251")
               (princ "\n    <>:")
               (princ "\nSelect Block with Attribute <all>:")
              )
            (or (setq ss (ssget "_:L" '((0 . "INSERT")(66 . 1))))
                (not (setvar "NOMUTT" 0))
                (setq ss (ssget "_X" (list '(0 . "INSERT")'(66 . 1)(cons 410 (getvar "CTAB")))))
                )
            (setvar "NOMUTT" 0)
            )
    (progn
      (bg:layer-status-save)
      (repeat (sslength ss)
        (setq Obj (vlax-ename->vla-object(ssname ss (setq i (1+ i)))))
        (if (and (= (vla-get-objectname Obj) "AcDbBlockReference")
                 (not (vlax-property-available-p Obj 'path))
                   )
            (foreach att (vlax-invoke Obj 'getattributes)
              (vla-put-color att Color)
            ) ;_ end of foreach
          )
	)
      (setvar "NOMUTT" 0)
      (bg:layer-status-restore)
      )
    )
  (vla-endundomark adoc)
  (princ)
  )
;;BG Color Block Level 2
(defun C:BGCBL2 (/ ss i obj color *error* adoc blocks)
  (defun *error* (msg)
    (setvar "NOMUTT" 0)
    (princ msg)
    (bg:layer-status-restore)
    (vla-endundomark adoc)
    (princ)
  ) ;_ end of defun

(setq adoc  (vla-get-activedocument (vlax-get-acad-object))
     blocks (vla-get-blocks adoc)
        i '-1)
  (vla-startundomark adoc)
  (if
    (and (setq color (acad_colordlg 256))
         (setvar "NOMUTT" 1)
         (if (= (getvar "DWGCODEPAGE") "ANSI_1251")
           (princ "\n  <>:")
           (princ "\nSelect Block <all>:")
         ) ;_ end of if
         (or (setq ss (ssget "_:L" '((0 . "INSERT"))))
             (not (setvar "NOMUTT" 0))
             (setq
               ss (ssget "_X"
                         (list '(0 . "INSERT") (cons 410 (getvar "CTAB")))
                  ) ;_ end of ssget
             ) ;_ end of setq
         ) ;_ end of or
         (setvar "NOMUTT" 0)
    ) ;_ end of and
     (progn
       (bg:layer-status-save)
       (repeat (sslength ss)
         (setq Obj (vlax-ename->vla-object (ssname ss (setq i (1+ i)))))
         (if (and (= (vla-get-objectname Obj) "AcDbBlockReference")
                  (not (vlax-property-available-p Obj 'path))
             ) ;_ end of and
           (vlax-for e (vla-item blocks (vla-get-name Obj))
             (if (and (= (vla-get-objectname e) "AcDbBlockReference")
                      (not (vlax-property-available-p e 'path))
                 ) ;_ end of and
               (_pl:block-color blocks e color (vla-get-layers adoc))
             ) ;_ end of if
           ) ;_ end of vlax-for
         ) ;_ end of if
       ) ;_ end of repeat
       (setvar "NOMUTT" 0)
       (bg:layer-status-restore)
     ) ;_ end of progn
  ) ;_ end of if
  (vla-endundomark adoc)
  (vla-regen adoc acallviewports)
  (princ)
) ;_ end of defun
;;;  ,     (  )
(defun C:BG1BLEXP ( / count xcount)
  (setq count (bg:block-explode-one-item)
	xcount (cadr count)
	count (car count)
	)
  
  (princ "\nExploded ")
  (princ count)
  (princ " blocks with one element. Found ")
  (princ xcount)
  (princ " blocks has xclip boundary.")
  (princ)
  )
;;  
(defun C:BGBLXCLIP ( / ss xss i blk)
  (setq i '-1 xss (ssadd))
  (if (setq ss (ssget "_X" (list '(0 . "INSERT")(cons 410 (getvar "CTAB")))))
    (progn
      (repeat (sslength ss)
	(if (bg:block-GetXclip (vlax-ename->vla-object(setq blk (ssname ss (setq i (1+ i))))))
	  (ssadd blk xss))
	)
      (sssetfirst nil xss)
      )
    )
  (princ "\nFound ")
  (princ (sslength xss))
    (princ " blocks has xclip boundary.")
  (setq ss nil xss nil)
  (princ)
  )

;;;  1- ,     
(defun C:BGBLEXP1NOATT ( / i ss blk count xcount tmp)
  (setq i '-1 count 0 xcount 0)
  (command "_.UNDO" "_Mark")
  (if (setq ss (ssget "_:L" (list '(0 . "INSERT")'(66 . 0)(cons 410 (getvar "CTAB")))))
    (progn
      (repeat (sslength ss)
	(if (and (setq tmp(bg:block-GetXclip (vlax-ename->vla-object(setq blk (ssname ss (setq i (1+ i)))))))
		 (= 1 (cdr(assoc 71 tmp)))
		 )
	  (setq xcount (1+ xcount))
	  (progn
	    (bg:explode-block blk nil)
	    (setq count (1+ count))
	    )
	  )
	)
      )
    )
  (princ "\nExploded ")
  (princ count)
  (princ " blocks. Found ")
  (princ xcount)
  (princ " blocks has xclip boundary.")
  (if(not(zerop count))(princ "\n*** Command _.UNDO _Back restore your drawing"))
  (princ)
  )
;;;  1- ,     
(defun C:BGBLEXP1 ( / i ss blk count xcount tmp)
  (setq i '-1 count 0 xcount 0)
  (command "_.UNDO" "_Mark")
  (if (setq ss (ssget "_:L" (list '(0 . "INSERT")(cons 410 (getvar "CTAB")))))
    (progn
      (vla-StartUndoMark (vla-get-activedocument (vlax-get-acad-object)))
      (repeat (sslength ss)
	(if (and (setq tmp(bg:block-GetXclip (vlax-ename->vla-object(setq blk (ssname ss (setq i (1+ i)))))))
		 (= 1 (cdr(assoc 71 tmp)))
		 )
	  (setq xcount (1+ xcount))
	  (progn
	    (bg:explode-block blk nil)
	    (setq count (1+ count))
	    )
	  )
	)
      (vla-EndUndoMark (vla-get-activedocument (vlax-get-acad-object)))
      )
    )
  (princ "\nExploded ")
  (princ count)
  (princ " blocks. Found ")
  (princ xcount)
  (princ " blocks has xclip boundary.")
  (if(not(zerop count))(princ "\n*** Command _.UNDO _Back restore your drawing"))
  (princ)
  )

;;;    ,   ,     
(defun C:BGBLEXP ( / i ss blk count xcount tmp)
  (setq i '-1 count 0 xcount 0)
  (command "_.UNDO" "_Mark")
  (if (setq ss (ssget "_:L" (list '(0 . "INSERT")(cons 410 (getvar "CTAB")))))
    (progn
      (vla-StartUndoMark (vla-get-activedocument (vlax-get-acad-object)))
      (repeat (sslength ss)
	(if (and (setq tmp(bg:block-GetXclip (vlax-ename->vla-object(setq blk (ssname ss (setq i (1+ i)))))))
		 (= 1 (cdr(assoc 71 tmp)))
		 )
	  (setq xcount (1+ xcount))
	  (progn
	    (bg:explode-block blk t)
	    (setq count (1+ count))
	    )
	  )
	)
      (vla-EndUndoMark (vla-get-activedocument (vlax-get-acad-object)))
      )
    )
  (princ "\nExploded ")
  (princ count)
  (princ " blocks. Found ")
  (princ xcount)
  (princ " blocks has xclip boundary.")
  (if(not(zerop count))(princ "\n*** Command _.UNDO _Back restore your drawing"))
  (princ)
  )



(defun C:APPDEL ( / nb nlst lst Rdn adoc )
  ;;;Mip Util mip-del-Rd
  (defun del-XDATA ( en Rdn / elist sub)
   (setq elist (entget en (list "*")) sub nil)
   (foreach i (cdr (assoc -3 elist))
     (if (not(wcmatch (strcase(car i))(strcase Rdn)))
       (setq sub (append sub (list i)))
       (setq sub (append sub (list(list (car i)))))
       ))
  (setq sub (cons -3 sub)
        elist (subst sub (assoc -3 elist) elist) 
        elist (entmod elist))
    )
  (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
;_   
  (if (setq nb (ssget "_X" '((-3 ("*")))))
    (progn
      (setq nlst nil lst (vl-remove-if 'listp (mapcar 'cadr (ssnamex nb))))
      (mapcar '(lambda (e1)
	     (mapcar '(lambda(rdn)
			(if (not(member rdn nlst))
			  (setq nlst(append nlst (list rdn)))))
                 (mapcar 'car (car(lib:massoc -3 (entget e1 '("*"))))))
	     )
	  lst)
      (setq nlst(vl-remove-if '(lambda(x)(wcmatch (strcase x) "ACAD*,ACDB*")) nlst))
      (setq Rdn (apply 'strcat (mapcar '(lambda(x)(strcat x ",")) nlst)))
      (mapcar '(lambda(x)(del-XDATA x Rdn)) lst)
      )
    )
   (princ "\n :")(mapcar 'print nlst)
;;;  (vlax-for a (vla-get-registeredapplications adoc) 
;;;(if (not (wcmatch  (setq Rdn(vla-get-name a)) "ACAD,ACAD*")) 
;;;(if (vl-catch-all-error-p(vl-catch-all-apply (function (lambda () 
;;;(vla-delete a)))))
;;;  (princ (strcat "\n " Rdn " - "))
;;;  (princ (strcat "\n " Rdn " -  "))
;;;  )
;;;  ))
 (princ))
 
 ; () -
;http://dwg.ru/f/showthread.php?t=11502
(defun C:UX ( / adoc blks u1 n obj objlist uname bname *error*)
  (defun *error* (msg)(princ msg)(mip:layer-status-restore)(vla-endundomark adoc)(princ))
(vl-load-com)
  (mip:layer-status-save)
(setq adoc (vla-get-activedocument (vlax-get-acad-object))
        blks (vla-get-blocks adoc)
        ) ;_ end of setq
  (vla-startundomark adoc)
  (if (and (setq uname (car (entsel "\n ")))
           (setq bname (cdr(assoc 2 (entget uname))))
         (wcmatch bname "`*U*")
         (setq obj (vlax-ename->vla-object uname))  
         (or (and (vlax-property-available-p obj "columns")
                  (vlax-property-available-p obj "rows")
                  (= (vla-get-columns (vlax-ename->vla-object uname)) 1)
                  (= (vla-get-rows (vlax-ename->vla-object uname)) 1)
                  )
             (and (not (vlax-property-available-p obj "columns"))
                  (not (vlax-property-available-p obj "rows"))
                  )
             )
         )
(progn
  (setq u1 (vla-item blks bname) n 1)
  (vlax-for obj u1
    (grtext -1 (strcat "  " (itoa n)))
    (setq objlist (cons obj objlist))
    (setq n (1+ n))
    )
 (setq n (vla-get-InsertionPoint (vlax-ename->vla-object uname))) 
 (grtext -1 "   " )
  (mapcar '(lambda(item)
             (vla-move item (vlax-3d-point '(0 0 0)) n)
             )
  (vlax-safearray->list
  (vlax-variant-value
(vla-copyobjects
                 (vla-get-activedocument (vlax-get-acad-object))
                 (vlax-make-variant
                   (vlax-safearray-fill
                     (vlax-make-safearray
                       vlax-vbobject
                       (cons 0 (1- (length objlist)))
                     ) ;_ end of vlax-make-safearray
                     objlist
                   ) ;_ end of vlax-safearray-fill
                 ) ;_ end of vlax-make-variant
                ;(vla-get-ModelSpace adoc)
               (vla-get-block (vla-get-ActiveLayout (vla-get-ActiveDocument (vlax-get-acad-object))))
               )
)
  )
          
          )
  (grtext -1 "   " )
  (entdel uname)
  )
  )
  (mip:layer-status-restore)
  (vla-endundomark adoc)
  (princ)
  )

(defun C:M2B ( / adoc blks u1 n obj objlist uname bname unnamed_block cpo tmp_blk ss lst)
;;;Convert Minsert block To Block
;;; Posted Vladimir Azarko (VVA)
;;; http://forum.dwg.ru/showthread.php?t=11502&page=3(vl-load-com) 
(setq adoc (vla-get-activedocument (vlax-get-acad-object)) 
        blks (vla-get-blocks adoc) 
        ) ;_ end of setq
  (vla-AuditInfo adoc :vlax-true)
  (vla-startundomark adoc)
  (if (setq ss (ssget "_:L" '((0 . "INSERT")
			      (-4 . "<OR")
			      (-4 . ">")(70 . 1)
			      (-4 . ">")(71 . 1)
			      (-4 . "OR>")
			      )))
(progn
  (repeat (setq n (sslength ss)) ;_ end setq
         (setq lst (cons (ssname ss (setq n (1- n))) lst))
         ) ;_ end
  (setq ss nil n 0)
  (foreach uname lst
    (grtext -1 (strcat "Working " (itoa (setq n (1+ n)))))
  (setq bname (cdr(assoc 2 (entget uname))))  
  (setq u1 (vla-item blks bname))
  (setq obj (vlax-ename->vla-object uname) objlist nil)  
  (vlax-for item u1 (setq objlist (cons item objlist)))
 (setq unnamed_block (vla-add (vla-get-blocks adoc)(vlax-3d-point '(0 0 0)) "*U"))
 (setq cpo (vla-copyobjects adoc
                 (vlax-make-variant 
                   (vlax-safearray-fill 
                     (vlax-make-safearray 
                       vlax-vbobject 
                       (cons 0 (1- (length objlist))) 
                     ) ;_ end of vlax-make-safearray 
                     objlist 
                   ) ;_ end of vlax-safearray-fill 
                 ) ;_ end of vlax-make-variant 
                ;(vla-get-ModelSpace adoc)
		 unnamed_block
               )
      )
  (setq tmp_blk (vla-insertblock
		  (vla-objectidtoobject adoc (vla-get-ownerid obj))
		  (vla-get-InsertionPoint obj)
		  (vla-get-name unnamed_block)
		  (vla-get-xscalefactor obj)(vla-get-yscalefactor obj)
	       (vla-get-zscalefactor obj)
		  ;(vla-get-rotation obj)
		  0
		  )
	)
  (setq cpo (vla-ArrayRectangular tmp_blk (vla-get-rows obj)(vla-get-columns obj) 1 (vla-get-RowSpacing obj)(vla-get-ColumnSpacing obj) 0))
  (setq cpo (vlax-safearray->list(vlax-variant-value cpo)))
  (setq cpo (cons tmp_blk cpo))
(foreach item cpo
	(vla-rotate item (vla-get-InsertionPoint obj) (vla-get-rotation obj))
	)
  (entdel uname)
    )
  (princ "Converting ")(princ n)(princ " minsert blocks")
  ) 
  ) 
  (vla-endundomark adoc)
(vl-cmdf "_.Redraw")
(princ)
)
  ;;;Convert Minsert block To Block
  ;;;http://dwg.ru/f/showthread.php?t=11502&page=3
(defun C:M2U ( / adoc blks u1 n obj objlist uname bname unnamed_block cpo tmp_blk ss lst)
(vl-load-com) 
(setq adoc (vla-get-activedocument (vlax-get-acad-object)) 
        blks (vla-get-blocks adoc) 
        ) ;_ end of setq 
  (vla-startundomark adoc)
  
  (if (setq ss (ssget "_:L" '((0 . "INSERT")(-4 . ">")(70 . 1)(71 . 1))))
(progn
  (repeat (setq n (sslength ss)) ;_ end setq
         (setq lst (cons (ssname ss (setq n (1- n))) lst))
         ) ;_ end
  (setq ss nil n 0)
  (foreach uname lst
    (grtext -1 (strcat "Working " (itoa (setq n (1+ n)))))
  (setq bname (cdr(assoc 2 (entget uname))))  
  (setq u1 (vla-item blks bname))
  (setq obj (vlax-ename->vla-object uname) objlist nil)  
  (vlax-for item u1 (setq objlist (cons item objlist)))
 (setq unnamed_block (vla-add (vla-get-blocks adoc)(vlax-3d-point '(0 0 0)) "*U"))
 (setq cpo (vla-copyobjects adoc
                 (vlax-make-variant 
                   (vlax-safearray-fill 
                     (vlax-make-safearray 
                       vlax-vbobject 
                       (cons 0 (1- (length objlist))) 
                     ) ;_ end of vlax-make-safearray 
                     objlist 
                   ) ;_ end of vlax-safearray-fill 
                 ) ;_ end of vlax-make-variant 
                ;(vla-get-ModelSpace adoc)
		 unnamed_block
               )
      )
  (setq tmp_blk (vla-insertblock
		  (vla-objectidtoobject adoc (vla-get-ownerid obj))
		  (vla-get-InsertionPoint obj)
		  (vla-get-name unnamed_block)
		  (vla-get-xscalefactor obj)(vla-get-yscalefactor obj)
	       (vla-get-zscalefactor obj)
		  ;(vla-get-rotation obj)
		  0
		  )
	)
  (setq cpo (vla-ArrayRectangular tmp_blk (vla-get-rows obj)(vla-get-columns obj) 1 (vla-get-RowSpacing obj)(vla-get-ColumnSpacing obj) 0))
  (setq cpo (vlax-safearray->list(vlax-variant-value cpo)))
  (setq cpo (cons tmp_blk cpo))
(foreach item cpo
	(vla-rotate item (vla-get-InsertionPoint obj) (vla-get-rotation obj))
	)
  (entdel uname)
    )
  (princ "Converting ")(princ n)(princ " minsert blocks")
  ) 
  ) 
  (vla-endundomark adoc)
(vl-cmdf "_.Redraw")
(princ)
)
(defun C:COLORXREF (/ doc col xreflist)
  (vl-load-com)
;;;  (alert
;;;    "\This lisp change color xref\nONLY ON A CURRENT SESSION"
;;;  ) ;_ end of alert
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark doc)
  (bg:layer-status-save)
   (vlax-for item (vla-get-Blocks doc)
      (if (= (vla-get-IsXref item) :vlax-true)
         (setq xreflist (cons (vla-get-name item) xreflist))
        )
     )
  (if (and xreflist
           (setq xreflist (_dwgru-get-user-dcl "  " (acad_strlsort xreflist) t))
           (setq col (acad_colordlg 7 t))
           )
    (ChangeXrefAllObjectsColor doc col xreflist) ;_ col  color number
  ) ;_ end of if
  (bg:layer-status-restore)
  (vla-endundomark doc)
  (princ)
) ;_ end of defun
(defun ChangeXrefAllObjectsColor (Doc Color xreflist / tmp txtstr txt count TrueColor pat )
  (setq xreflist (mapcar 'strcase xreflist))  
  (setq pat(mapcar '(lambda(x)(strcat x "|*,")) xreflist))
  (setq pat (apply 'strcat pat))

  (vlax-for item (vla-get-Layers doc)
      (if (wcmatch (strcase (vla-get-name item)) pat)
	(vla-put-color item color)
      )
    )
  (vlax-for Blk	(vla-get-Blocks Doc)
    (cond
      (
       (or (and (= (vla-get-IsXref Blk) :vlax-true)
                (member (strcase(vla-get-name Blk)) xreflist)
                )
	   (and	(= (vla-get-IsXref Blk) :vlax-false)
		(wcmatch (vla-get-name Blk) pat );_ "*|*"
	   ) ;_ end of and
       ) ;_ end of or
       
       	(setq count 0 txt (strcat "Changed " (vla-get-name Blk)))
        (grtext -1 txt)
       (vlax-for Obj Blk
      	(setq count (1+ count))
	(if (zerop(rem count 10))(grtext -1 (strcat txt " : " (itoa count))))
         (if (and (vlax-write-enabled-p Obj)(vlax-property-available-p Obj 'TrueColor))
           (progn
             (setq TrueColor (vla-get-TrueColor obj))
             (vla-put-ColorMethod TrueColor acColorMethodByACI)
             (vla-put-ColorIndex TrueColor Color)
             (vla-put-TrueColor obj TrueColor)
             )
           )
	 (if (and (vlax-write-enabled-p Obj)
		  (vlax-property-available-p Obj 'Color)
	     ) ;_ end of and
	   (vla-put-Color Obj Color)
	 ) ;_ end of if
	 (if (and (vlax-write-enabled-p Obj)
		 (vlax-property-available-p Obj 'TextString)
	    ) ;_ end of and
	  (progn
	    (setq txtstr
		   (if (vlax-method-applicable-p Obj 'FieldCode)
		       (vla-FieldCode Obj)
		       (vlax-get-property Obj 'TextString))
		  )
	    (setq tmp 0)
	     (while (setq tmp (VL-STRING-SEARCH "\\C" txtstr tmp))
	      (setq txtstr
	      (vl-string-subst
		(strcat (substr txtstr (1+ tmp) 2)(itoa Color) ";")
		(substr txtstr (1+ tmp) (- (1+ (VL-STRING-SEARCH ";" txtstr tmp)) tmp))
		txtstr
		tmp)
		    )
	      (setq tmp (+ tmp 3))
	      )
	    (vla-put-Textstring Obj txtstr)
	    )
	) ;_ end of if
	 (if (and (vlax-write-enabled-p Obj)
		  (= (vla-get-ObjectName obj) "AcDbBlockReference")
		  (= (vla-get-HasAttributes obj) :vlax-true)
	     ) ;_ end of and
           (vl-catch-all-apply '(lambda()
	   (foreach att	(vlax-safearray->list
			  (vlax-variant-value (vla-GetAttributes obj))
			) ;_ end of vlax-safearray->list
	     (if (and (vlax-write-enabled-p att)
		      (vlax-property-available-p att 'Color)
		 ) ;_ end of and
	       (vla-put-Color att Color)
	     ) ;_ end of if
	   ) ;_ end of foreach
                                  )
             )
	 ) ;_ end of if
	 (if (and (vlax-write-enabled-p Obj)
		  (wcmatch (vla-get-Objectname Obj) "*Dimension*,AcDb*Leader")
	     ) ;_ end of and
	   (progn
	     (vl-catch-all-apply 'vla-put-ExtensionLineColor (list Obj Color))
	     (vl-catch-all-apply 'vla-put-TextColor (list Obj Color))
	     (vl-catch-all-apply 'vla-put-DimensionLineColor (list Obj Color))
	     (if (vlax-property-available-p Obj 'LeaderLineColor)
	       (progn
		 (setq tmp (vla-getinterfaceobject(vlax-get-acad-object)(strcat "AutoCAD.AcCmColor."
		(substr (getvar "ACADVER") 1 2))))
		 (vla-put-colorindex  tmp  Color)
		 (vl-catch-all-apply 'vla-put-LeaderLineColor (list Obj tmp))
		 )
	       )
	   ) ;_ end of progn
	 ) ;_ end of if
       ) ;_ end of vlax-for
      )
      ((= (vla-get-IsLayout Blk) :vlax-true)
       (vlax-for Obj Blk
	 (if
	   (and	(vlax-write-enabled-p Obj)
		(vlax-property-available-p Obj 'Color)
		(vlax-property-available-p Obj 'Path)
		(wcmatch (strcase (vla-get-ObjectName Obj)) "*BLOCK*")
	   ) ;_ end of and
	    (vla-put-Color Obj Color)
	 ) ;_ end of if
       ) ;_ end of vlax-for
      )
      (t nil)
    ) ;_cond
  ) ;_ end of vlax-for
    ;;;  
  (vl-catch-all-apply
    '(lambda ()
       (entmod
         (mapcar '(lambda (x / y)
                    (if (= (car x) 350)
                      (progn
                        (setq y (mapcar '(lambda (z)
                                           (if (= (car z) 62)
                                             (cons 62 color)
                                             z
                                           ) ;_ end of if
                                         ) ;_ end of lambda
                                        (entget (cdr x))
                                ) ;_ end of mapcar
                        ) ;_ end of setq
                        (cons 350 (entmakex y))
                      ) ;_ end of progn
                      x
                    ) ;_ end of if
                  ) ;_ end of lambda
                 (dictsearch (namedobjdict) "ACAD_MLINESTYLE")
         ) ;_ end of mapcar
       ) ;_ end of entmod
     ) ;_ end of lambda
  ) ;_ end of vl-catch-all-apply
  (vl-cmdf "_regenalll")
) ;_ end of defun


(if (= (getvar "DWGCODEPAGE") "ANSI_1251")
(progn
  (princ "\nBackground tools Ver. 1.12    :")
  (princ "\nBGLAYDEL -       ")
  (princ "\nBG1BLEXP -  ,     (  )")
  (princ "\nBGBLEXP  -     ,   ,     ")
  (princ "\nBGBLEXP1 -   1- ,     ") 
  (princ "\nBGBLEXP1NOATT -   1- ,     ")
  (princ "\nBGBLXCLIP -   ")
  (princ "\n=======================================")
  (princ "\nBGCOLOR -     ")
  (princ "\nBGBLCC -    ")
  (princ "\nBGENCC -     ")
  (princ "\nBGCATT -     ")
  (princ "\nBGCBL2 -     2    ( )")  
  (princ "\nBGBLFIX -  ")
  )
(progn
  (princ "\nBackground tools Ver. 1.12 Type in command line:")
  (princ "\nBGLAYDEL - delete frozen and off layers with objects")
  (princ "\nBG1BLEXP - Explode blocks consisting of one primitive thing (it is possible other block)")
  (princ "\nBGBLEXP  - Explode the block and all blocks entering into it, transforming visible attributes in the text")
  (princ "\nBGBLEXP1 - Explode blocks of 1st level, transforming visible attributes in the text")
  (princ "\nBGBLEXP1NOATT -Explode blocks of 1st level which do not have visible attributes ")
  (princ "\nBGBLXCLIP - show xclip blocks")
  (princ "\n=======================================")
  (princ "\nBGCOLOR - Sets the chosen colour to all objects")
  (princ "\nBGBLCC - Changes color of the chosen blocks")
  (princ "\nBGENCC - Changes color of the chosen element of the block")
  (princ "\nBGCATT - Changes color of attributes of the chosen blocks")
  (princ "\nBGCBL2 - Changes color in blocks 2 and more levels (the enclosed blocks)")
  (princ "\nBGBLFIX - fix (normalize) blocks")
  

    )
  )



