(defun c:bchange (/
		  sel-blk
		  ent-is-block-check
		  block-change
		  ss
		  ent1
		  ent2
		  adoc
		 )

;;; :
;;;*****************************************************************************************

  (defun sel-blk (msg / ent safe-sel)
;;; (sel-blk "\nSelect block for change:")  
    (defun safe-sel (txt / ent)
;;; (safe-sel "\nSelect object:")
      (while
	(not
	  (setq	ent
		 (vl-catch-all-apply
		   (function (lambda () (entsel txt)))
		 ) ;_ end of vl-catch-all-apply
	  ) ;_ end of setq
	) ;_ end of not
      ) ;_ end of while
      (if (vl-catch-all-error-p ent)
	nil
	ent
      ) ;_ end of if
    ) ;_ end of defun

    (cond
      ((not (setq ent (safe-sel msg))) nil)
      ((not (ent-is-block-check
	      (setq ent (car ent))
	    ) ;_ end of ent-is-block-check
       ) ;_ end of not
       (prompt "\n   !")
       "not block"
      )
      (T ent)
    ) ;_ end of cond
  ) ;_ end of defun

  (defun ent-is-block-check (ent)
;;; (ent-is-block-check (car (entsel "\nSelect object:")))
    (if	(= (type ent) (quote ename))
      (setq ent (vlax-ename->vla-object ent))
    ) ;_ end of if
    (and (= (vla-get-ObjectName ent) "AcDbBlockReference")
	 (not (vlax-property-available-p ent "Path"))
    ) ;_ end of and
  ) ;_ end of defun

  (defun block-change (ent1
		       ent2
		       /
		       GetDynamicBlockPropertyList
		       _kpblc-block-dyn-change-values
		       block-get-attribute-list
		       conv-to-vla
		       adoc
		       pspace
		       mspace
		       dyn_prop_lst1
		       dyn_prop_lst2
		       att_lst_1
		       att_lst_2
		      )

;;;  ent1 -  
;;;  ent2 - -

    (defun GetDynamicBlockPropertyList (obj / lstProperties)
;;;   :
;;;  http://forum.abok.ru/index.php?s=1de2a0c8487766acc0dc518a3f769d93&showtopic=14612&view=findpost&p=171367
;;;       .
;;;  (GetDynamicBlockPropertyList (vlax-ename->vla-object (car (entsel "\nSelect dynamic block:"))))
;;;  :
;;;  -->(("Visibility" " " #<VLA-OBJECT IAcadDynamicBlockReferenceProperty 0a8f7264>))
;;;  :
;;;  -->(("Visibility" . " "))
      (if (and (vlax-property-available-p obj "IsDynamicBlock")
	       (= (vla-get-IsDynamicBlock obj) :vlax-true)
	       (not (vl-catch-all-error-p
		      (setq lstProperties
			     (vl-catch-all-apply
			       (function (lambda ()
					   (vlax-safearray->list
					     (variant-value
					       (vla-GetDynamicBlockProperties obj)
					     ) ;_ end of variant-value
					   ) ;_ end of vlax-safearray->list
					 ) ;_ end of lambda
			       ) ;_ end of function
			     ) ;_ end of vl-catch-all-apply
		      ) ;_ end of setq
		    ) ;_ end of vl-catch-all-error-p
	       ) ;_ end of not
	       lstProperties
	  ) ;_ end of and
	(progn
	  (mapcar '(lambda (x)
		     (cons (vla-get-propertyname X)
			   (variant-value (vla-get-value X))
			   ;;		       x
		     ) ;_ end of list
		   ) ;_ end of lambda
		  lstProperties
	  ) ;_ end of mapcar
	) ;_ end of progn
      ) ;_ end of if
    ) ;_ end of defun

    (defun _kpblc-block-dyn-change-values (ent
					   lst
					   /
					   prop_lst
					   _kpblc-conv-vla-to-list
					  )
					  ;|
	ent	   
	lst	 :
      '((<property> . <value>)
	(<property> . <value>)
	)
*     :
(_kpblc-block-dyn-change-values (car(entsel))'(("dist*" . 162.56) ("ang*" . 5.)))
;;     !
(_kpblc-block-dyn-change-values (car (entsel)) '(("Visibility" . "")))
|;

      (defun _kpblc-conv-vla-to-list (value / res)
				     ;|
*     vlax-variant  vlax-safearray  .
|;
	(cond
	  ((= (type value) 'variant)
	   (_kpblc-conv-vla-to-list (vlax-variant-value value))
	  )
	  ((= (type value) 'safearray)
	   (if (>= (vlax-safearray-get-u-bound value 1) 0)
	     (vlax-safearray->list value)
	   ) ;_ end of if
	  )
	  (t value)
	) ;_ end of cond
      ) ;_ end of defun

      (vl-load-com)
      (if (and ent
	       (setq
		 ent (cond
		       ((= (type ent) 'ename) (vlax-ename->vla-object ent))
		       ((= (type ent) 'vla-object) ent)
		       (t nil)
		     ) ;_ end of cond
	       ) ;_ end of setq
	       (= (strcase (vla-get-objectname ent) t)
		  "acdbblockreference"
	       ) ;_ end of =
	       (= (vla-get-isdynamicblock
		    (vla-item
		      (vla-get-blocks
			(vla-get-activedocument (vlax-get-acad-object))
		      ) ;_ end of vla-get-blocks
		      (vla-get-effectivename ent)
		    ) ;_ end of vla-item
		  ) ;_ end of vla-get-isdynamicblock
		  :vlax-true
	       ) ;_ end of =
	  ) ;_ end of and
	(progn
	  (setq
	    prop_lst (vlax-safearray->list
		       (vlax-variant-value
			 (vla-getdynamicblockproperties ent)
		       ) ;_ end of vlax-variant-value
		     ) ;_ end of vlax-safearray->list
	  ) ;_ end of setq
	  (foreach item
		   (mapcar '(lambda (a) (cons (strcase (car a)) (cdr a)))
			   lst
		   ) ;_ end of mapcar
	    (if	(setq prop
		       (car
			 (vl-remove-if-not
			   '(lambda (x)
			      (wcmatch (strcase (vla-get-propertyname x))
				       (car item)
			      ) ;_ end of wcmatch
			    ) ;_ end of lambda
			   prop_lst
			 ) ;_ end of vl-remove-if-not
		       ) ;_ end of car
		) ;_ end of setq
	      ;;  
	      (vl-catch-all-apply
		'(lambda ()
		   (vla-put-value
		     prop
		     (vlax-make-variant
		       (cdr item)
		       (vlax-variant-type (vla-get-value prop))
		     ) ;_ end of vlax-make-variant
		   ) ;_ end of vla-put-value
		   (vla-update ent)
		 ) ;_ end of lambda
	      ) ;_ end of vl-catch-all-apply
	    ) ;_ end of if
	  ) ;_ end of foreach
	) ;_ end of progn
      ) ;_ end of if
    ) ;_ end of defun

    (defun block-get-attribute-list (blk / lst)
      ;; (block-get-attribute-list (car (entsel "\nSelect block:")))
      (if (= (type blk) (quote ename))
	(setq blk (vlax-ename->vla-object blk))
      ) ;_ end of if
      (if
	(vl-catch-all-error-p
	  (setq	lst
		 (vl-catch-all-apply
		   (function (lambda ()
			       (vlax-safearray->list
				 (vlax-variant-value
				   (vla-getattributes
				     blk
				   ) ;_ end of vla-getattributes
				 ) ;_ end of vlax-variant-value
			       ) ;_ end of vlax-safearray->list
			     ) ;_ end of lambda
		   ) ;_ end of function
		 ) ;_ end of vl-catch-all-apply
	  ) ;_ end of setq
	) ;_ end of vl-catch-all-error-p
	 nil
	 lst
      ) ;_ end of if
    ) ;_ end of defun


    (defun conv-to-vla (val)
      (cond
	((= (type val) (quote vla-object)) val)
	((= (type val) (quote ename)) (vlax-ename->vla-object val))
      ) ;_ end of cond
    ) ;_ end of defun


    (vl-load-com)
    (setq
      adoc   (vla-get-ActiveDocument (vlax-get-acad-object))
      pspace (vla-get-PaperSpace adoc)
      mspace (vla-get-ModelSpace adoc)
      ent1   (conv-to-vla ent1)
      ent2   (conv-to-vla ent2)
      ent2   (vla-InsertBlock
	       (if
		 (= (cdr (assoc 67 (entget (vlax-vla-object->ename ent1))))
		    0
		 ) ;_ end of =
		  mspace
		  pspace
	       ) ;_ end of if
	       (vla-get-InsertionPoint ent1)
	       (vla-get-EffectiveName ent2)
	       (vla-get-XScaleFactor ent1)
	       (vla-get-YScaleFactor ent1)
	       (vla-get-ZScaleFactor ent1)
	       (vla-get-Rotation ent1)
	     ) ;_ end of vla-InsertBlock
    ) ;_ end of setq 
    (mapcar
      (function
	(lambda	(prop)
	  (vlax-put-property ent2 prop (vlax-get-property ent1 prop))
	) ;_ end of lambda
      ) ;_ end of function
      (list "Layer"
	    "Linetype"
	    "LinetypeScale"
	    "Lineweight"
	    "Normal"
	    "InsertionPoint"
	    "Rotation"
	    ;;"PlotStyleName"
	    "TrueColor"
	    "Visible"
      ) ;_ end of list
    ) ;_ end of mapcar
    (if	(and (setq dyn_prop_lst1 (GetDynamicBlockPropertyList ent1))
	     (setq dyn_prop_lst2 (GetDynamicBlockPropertyList ent2))
	     (vl-some (function (lambda (a b) (= (car a) (car b))))
		      dyn_prop_lst1
		      dyn_prop_lst2
	     ) ;_ end of vl-some
	) ;_ end of and
      (_kpblc-block-dyn-change-values ent2 dyn_prop_lst1)
    ) ;_ end of if
    (if	(and (setq att_lst_1 (block-get-attribute-list ent1))
	     (setq att_lst_2 (block-get-attribute-list ent2))
	     (= (length att_lst_1) (length att_lst_2))
	) ;_ end of and
      (mapcar
	(function
	  (lambda (att1 att2)
	    (mapcar
	      (function
		(lambda	(prop)
		  (if (and (= prop "TextGenerationFlag"))
		    (progn
		      (entmod
			(list
			  (cons -1 (vlax-vla-object->ename att2))
			  (cons
			    71
			    (cdr (assoc
				   71
				   (entget (vlax-vla-object->ename att1))
				 ) ;_ end of assoc
			    ) ;_ end of cdr
			  ) ;_ end of cons
			) ;_ end of list
		      ) ;_ end of entmod
		    ) ;_ end of progn
		    (vl-catch-all-apply
		      (function
			(lambda	()
			  (vlax-put-property
			    att2
			    prop
			    (vlax-get-property att1 prop)
			  ) ;_ end of vlax-put-property
			) ;_ end of lambda
		      ) ;_ end of function
		    ) ;_ end of vl-catch-all-apply
		  ) ;_ end of if
		) ;_ end of lambda
	      ) ;_ end of function
	      (list
		"Alignment"
		"Backward"
		"FieldLength"
		"Height"
		"InsertionPoint"
		"Invisible"
		"Layer"
		"Linetype"
		"LinetypeScale"
		"Lineweight"
		"Normal"
		"ObliqueAngle"
		;;"PlotStyleName"
		"Rotation"
		"ScaleFactor"
		"StyleName"
		"TagString"
		"TextString"
		"TextAlignmentPoint"
		"TextGenerationFlag"
		"Thickness"
		"TrueColor"
		"UpsideDown"
		"Visible"
	      ) ;_ end of list
	    ) ;_ end of mapcar
	  ) ;_ end of lambda
	) ;_ end of function
	att_lst_1
	att_lst_2
      ) ;_ end of mapcar
    ) ;_ end of if
    (vla-delete ent1)
    (vla-update ent2)
  ) ;_ end of defun


;;; :
;;;*****************************************************************************************

  (if (and (setq ss (ssget "_I" (quote ((0 . "INSERT")))))
	   (= 1 (sslength ss))
	   (ent-is-block-check (setq ent2 (ssname ss 0)))
      ) ;_ end of and
    (setq ent2 (vlax-ename->vla-object ent2))
    (setq ent2 (sel-blk "\n -:"))
  ) ;_ end of if
  (sssetfirst nil nil)
  (if ent2
    (while (setq ent1 (sel-blk "\n   (Esc-.):"))
      (if (and (/= ent1 "not block") (not (equal ent1 ent2)))
	(progn
	  (vla-StartUndoMark
	    (setq adoc (vla-get-ActiveDocument (vlax-get-acad-object)))
	  ) ;_ end of vla-StartUndoMark
	  (block-change ent1 ent2)
	  (vla-EndUndoMark adoc)
	) ;_ end of progn
      ) ;_ end of if
    ) ;_ end of while
  ) ;_ end of if
  (princ)
) ;_ end of defun
