(defun c:close-all-save    (/ acapp adoc)    ;close with saving changes
  (vl-load-com)
  (setvar "sdi" 0)
  (setq acapp (vlax-get-acad-object))
  (vlax-for adoc
         (vla-get-documents
           acapp
         )
    (vl-catch-all-apply
      (function    (lambda    ()
          (vla-close adoc)
        )
      )
    )
  )
  (vla-put-windowstate (vla-get-activedocument acapp) acmax)
  (vla-put-windowstate (vlax-get-acad-object) acmin)
  (command "_.vbastmt" "activedocument.close true")
  (command "_.vbastmt" "application.quit ")
  (princ)
)
 
 
 
 
(defun c:close-all-no-save (/ acapp curdoc) ;close without saving changes
  (vl-load-com)
  (setvar "sdi" 0)
  (setq acapp (vlax-get-acad-object))
  (setq    cnt (vla-get-count
          (vla-get-documents acapp)
        )
    num cnt
  )
  (repeat num
    (setq curdoc (vla-item (vla-get-documents acapp) (1- cnt)))
    (vl-catch-all-apply
      (function    (lambda    ()
          (vla-close curdoc :vlax-false fname)
        )
      )
    )
    (vlax-release-object curdoc)
    (setq cnt (1- cnt))
  )
  (vla-put-windowstate (vla-get-activedocument acapp) acmax)
  (vla-put-windowstate (vlax-get-acad-object) acmin)
  (command "_.vbastmt" "activedocument.close false")
  (command "_.vbastmt" "application.quit ")
  (princ)
)