(defun c:compilation_survey
			    (/		   make_hod_rec	 LWp
			     temp	   adoc		 dist
;;;;;;;;;;;;;;;;;;;;;;;
			     make_hod_rec  make_spline	 add_midl_rec
			     midl_point	   make_lwp	 makedoublesafe
			     geo_vibor
			    )
;;;;;;
;;;;;;make_hod_rec
;;;;;;
  (defun make_hod_rec (_list	    /		 AngleVertexP
		       FirstEndP    SecondEndP	 TextP
		      )
    (cond
      ((>= (length _list) 3)
       (setq
	 FirstEndP  (car _list)
	 SecondEndP (cadr _list)
	 TextP	    (polar
		      FirstEndP
		      ((if (eq user_side_for_put_angle "")
			 +
			 -
		       )
			(angle FirstEndP SecondEndP)
			(/ pi 2)
		      )
		      user_dist_for_put_angle
		    )
       )
       (vla-AddDimAligned
	 (vla-get-modelspace adoc)
	 (vlax-3d-point FirstEndP)
	 (vlax-3d-point SecondEndP)
	 (vlax-3d-point TextP)
       )
       (setq
	 AngleVertexP SecondEndP
	 FirstEndP    (polar AngleVertexP
			     (angle AngleVertexP
				    FirstEndP
			     )
			     dist_for_angle
		      )
	 SecondEndP   (polar AngleVertexP
			     (angle AngleVertexP
				    (caddr _list)
			     )
			     dist_for_angle
		      )
	 TextP	      (polar
			AngleVertexP
			((if (eq user_side_for_put_angle "")
			   -
			   +
			 )
			  (angle AngleVertexP SecondEndP)
			  0.0003
			)
			dist_for_angle
		      )
       )
       (vla-AddDim3PointAngular
	 (vla-get-modelspace adoc)
	 (vlax-3d-point AngleVertexP)
	 (vlax-3d-point FirstEndP)
	 (vlax-3d-point SecondEndP)
	 (vlax-3d-point TextP)
       )
       (make_hod_rec (cdr _list))
      )
      ((= (length _list) 2)
       (setq
	 FirstEndP  (car _list)
	 SecondEndP (cadr _list)
	 TextP	    (polar
		      FirstEndP
		      ((if (eq user_side_for_put_angle "")
			 +
			 -
		       )
			(angle FirstEndP SecondEndP)
			(/ pi 2)
		      )
		      user_dist_for_put_angle
		    )
       )
       (vla-AddDimAligned
	 (vla-get-modelspace adoc)
	 (vlax-3d-point FirstEndP)
	 (vlax-3d-point SecondEndP)
	 (vlax-3d-point TextP)
       )
      )
      (t t)
    )
  )

;;;
;;;make_spline
;;;
  (defun make_spline (_list /)
    (setq spline_obj
	   (vla-addspline
	     (vla-get-modelspace adoc)
	     (makedoublesafe _list)
	     (vlax-3d-point '(0 0 0))
	     (vlax-3d-point '(0 0 0))
	   )
    )
  )

;;;
;;;add_midl_rec
;;;
  (defun add_midl_rec (_list flag /)
    (cond
      ((cadr _list)
       (setq st-P (car _list)
	     en_p (cadr _list)
       )
       (cons
	 st-P
	 (cons
	   (polar
	     (mapcar (function (lambda (x y) (/ (+ x y) 2.0)))
		     st-P
		     en_p
	     )
	     ((cond
		(flag
		 (setq flag nil)
		 +
		)
		(t
		 (setq flag t)
		 -
		)
	      )
	       (angle st-P en_p)
	       (/ pi 2.0)
	     )
	     dist_for_spline
	   )
	   (add_midl_rec (cdr _list) flag)
	 )
       )
      )
      (t _list)
    )
  )



;;;
;;;midl_point
;;;
  (defun midl_point (_list /)
    (if	(cdr _list)
      (cons (cadr _list) (midl_point (cdr (cdr _list))))
    )
  )


;;;
;;;make_lwp
;;;
  (defun make_lwp (_list /)
    (entmakex
      (append
	(list
	  (cons 0 "LWPOLYLINE")
	  (cons 100 "AcDbEntity")
	  (cons 100 "AcDbPolyline")
	  (cons 90 2)
	  (cons 70 0)
	  (cons 10 (car _list))
	  (cons 40 dist_for_arr_2)
	  (cons 41 0.0)
	  (cons 42 (caddr _list))
	  (cons 10 (cadr _list))
	)
      )
    )
  )
;;;
;;;makedoublesafe
;;;

  (defun makedoublesafe	(lst / list_)
    (setq list_ (apply 'append lst))
    (vlax-safearray-fill
      (vlax-make-safearray
	vlax-vbdouble
	(cons 0 (1- (length list_)))
      )
      list_
    )
  )
;;;
;;;geo_vibor
;;;
  (defun geo_vibor (zap tip sloy exit_ / flag name ru)
    (setq Flag t
	  ru   (= (getvar "SysCodePage") "ANSI_1251")
    )
    (setvar "ERRNO" 0)
    (while Flag
      (setq name
	     (car (entsel zap))
      )
      (cond
					;
	((and exit_ (= (getvar "ERRNO") 52))
	 (setq Flag nil)
	)
	((not name)
	 (princ	(if ru
		  "\n :( "
		  "\nMiss :( "
		)
	 )
	)
					;
	((not
	   (wcmatch (cdr (assoc 0 (entget name)))
		    tip
	   )
	 )
	 (princ
	   (strcat
	     (if ru
	       "\n   ,  : "
	       "\n Bad object that must be: "
	     )
	     tip
	   )
	 )
	)
					;
	((not
	   (wcmatch (cdr (assoc 8 (entget name)))
		    sloy
	   )
	 )
	 (princ
	   (strcat
	     (if ru
	       "\n     ,   "
	       "\nSelected object not on the right layer, must be "
	     )
	     sloy
	   )
	 )
	)
					;
	(t
	 (setq Flag nil
	       name name
	 )
	)
					;
      )
    )
  )

;;;
;;;group-by-num
;;;
  (defun group-by-num (lst num / ls ret)
    (if	(= (rem (length lst) num) 0)
      (progn
	(setq ls nil)
	(repeat	(/ (length lst) num)
	  (repeat num
	    (setq ls
		      (cons (car lst) ls)
		  lst (cdr lst)
	    )
	  )
	  (setq	ret (append ret (list (reverse ls)))
		ls  nil
	  )
	)
      )
    )
    ret
  )
;;;;;;;;;;;;;;;;;;;;;;;;  
  (vl-load-com)
  (if (setq LWp
	     (geo_vibor
	       "\n  () <>: "
	       "LWPOLYLINE"
	       "*"
	       t
	     )
      )
    (progn
      (or user_dist_for_put_angle
	  (setq user_dist_for_put_angle 20)
      )
      (or user_side_for_put_angle
	  (setq user_side_for_put_angle "")
      )
      (initget "  _ ")
      (setq user_side_for_put_angle
	     (if (setq temp
			(getkword (strcat "\n  [/] <"
					  user_side_for_put_angle
					  ">:"
				  )
			)
		 )
	       temp
	       user_side_for_put_angle
	     )
      )
      (or user_select_for_make_hod
	  (setq user_select_for_make_hod "")
      )
      (initget ".   _  ")
      (setq user_select_for_make_hod
	     (if (setq temp
			(getkword (strcat "\n [.//] <"
					  user_select_for_make_hod
					  ">:"
				  )
			)
		 )
	       temp
	       user_select_for_make_hod
	     )
      )
      (setq
	user_dist_for_put_angle
	 (if (setq temp
		    (getdist
		      (strcat
			"\n  <"
			(vl-princ-to-string
			  user_dist_for_put_angle
			)
			">: "
		      )
		    )
	     )
	   temp
	   user_dist_for_put_angle
	 )
	dist_for_angle
	 (* user_dist_for_put_angle 1.5)
	dist_for_spline
	 (/ user_dist_for_put_angle 2.0)
	dist_for_arr_1
	 (/ user_dist_for_put_angle 3.0)
	dist_for_arr_2
	 (/ user_dist_for_put_angle 5.0)
	point_list
	 (group-by-num
	   (vlax-get
	     (vlax-ename->vla-object
	       LWp
	     )
	     'Coordinates
	   )
	   2
	 )
	adoc (vla-get-activedocument
	       (vlax-get-acad-object)
	     )
      )
      (vla-startundomark adoc)
      (if (or (eq user_select_for_make_hod "")
	      (eq user_select_for_make_hod "")
	  )
	(make_hod_rec point_list)
      )
      (if (or (eq user_select_for_make_hod "")
	      (eq user_select_for_make_hod "")
	  )
	(progn
	  (setq	point_list
		 (mapcar
		   (function (lambda (x) (list (car x) (cadr x) 0)))
		   (add_midl_rec point_list t)
		 )
	  )
	  (make_spline point_list)
	  (setq midl_poin_list (midl_point point_list))
	  (setq	point_for_arrow
		 (mapcar (function (lambda (x)
				     (setq t2	(Vlax-curve-getParamAtPoint
						  spline_obj
						  x
						)
					   t1	(Vlax-Curve-getPointAtParam
						  spline_obj
						  (- t2 dist_for_arr_1)
						)
					   t3	(Vlax-Curve-getPointAtParam
						  spline_obj
						  (+ t2 dist_for_arr_1)
						)
					   t1-3	(mapcar
						  (function
						    (lambda (x y) (/ (+ x y) 2.0))
						  )
						  t1
						  t3
						)
					   tan	(/ (distance t1-3 x)
						   (distance t1 t3)
						   0.5
						)
					   angl	(- (angle t1 t3) (angle t1 x))
					   angl	(if (minusp angl)
						  (+ (* 2 pi) angl)
						  angl
						)
					   tan	(if (< 0 angl pi)
						  tan
						  (- 0 tan)
						)
				     )
				     (list t1 t3 tan)
				   )
			 )
			 midl_poin_list
		 )
	  )
	  (mapcar 'make_lwp point_for_arrow)
	)
      )
      (vla-endundomark adoc)
    )
  )
)


