;         
;
;(ccons '(1 2 3 4 5 6))
(defun ccons (lstin)
	(if (not (= lstin nil))
		(cons (cons (car lstin) (cadr lstin)) (ccons (cddr lstin)))
	)
)

; 
;(getvar "TEXTSTYLE")

;     ,  ,  
;   
;(drawtxt (getpoint) 3 "center" "teststring value")
(defun drawtxt (pt th just txtstr)
	(setq just
		(cond
			((= just "left")	(list 72 0 73 0))
			((= just "center")	(list 72 1 73 0))
			((= just "right")	(list 72 2 73 0))
			((= just "tl")		(list 72 0 73 3))
			((= just "tc")		(list 72 1 73 3))
			((= just "tr")		(list 72 2 73 3))
			((= just "ml")		(list 72 0 73 2))	
			((= just "mc")		(list 72 1 73 2))
			((= just "mr")		(list 72 2 73 2))	
			((= just "bl")		(list 72 0 73 1))
			((= just "bc")		(list 72 1 73 1))
			((= just "br")		(list 72 2 73 1))
		)
	)

	(entmake (append (ccons (list
			0 "TEXT"
			100 "AcDbEntity"
			100 "AcDbText"
			1 txtstr
			40 th
			51 (cdr (assoc 50 (tblsearch "STYLE" (getvar 'textstyle))))
			10 pt
			11 pt
			7 (getvar "TEXTSTYLE")
			)) (ccons just)))
)

;    , ,  , 
;    ,    
;(mkmtxt (getpoint) 3 "mc" 0.45 12 "teststring value")
(defun mkmtxt (pt th just row_space cellw txtstr / base)

	(setq base (list
			0 "MTEXT" 100 "AcDbEntity" 100 "AcDbMText" 1 txtstr 40 th 10 pt 11 pt 		
			41 cellw 44 row_space 50 0.0 7 (getvar 'textstyle) 
		))

	(setq just
		(cond
			((= just "tl") '(71 1))
			((= just "tc") '(71 2))
			((= just "tr") '(71 3))
			((= just "ml") '(71 4))	
			((= just "mc") '(71 5))
			((= just "mr") '(71 6))	
			((= just "bl") '(71 7))
			((= just "bc") '(71 8))
			((= just "br") '(71 9))
		)
	)

	(entmake (ccons (append base just)))
)

;       X   
(defun ofstx (pt ofstd)
	(list (+ ofstd (car pt)) (cadr pt))
)

;       Y     
(defun ofsty (pt ofstd)
	(list (car pt) (- (cadr pt) ofstd))
)

;        
(defun mkptxlist (pt pts)
	(if pts (cons (setq pt (ofstx pt (car pts))) (mkptxlist pt (cdr pts))))
)
	
;        
(defun mkptylist (pt ofstd rows)
	(if (>= rows 0)
		(cons pt (mkptylist (ofsty pt ofstd) ofstd (1- rows)))
	)
)

;           
(defun draw_line (pts ang lh)
	(mapcar '(lambda (x) (command "_.line" x (polar x ang lh) "")) pts))



;      , ,  ,
;     
;(drawtxtptstrlst ptlistx txth justlist (cadr (gtable)) interlist)
;(drawtxtptstrlst ptlistx txth justlist (cadr mlst) interlist)

;(defun drawtxtptstrlst (ptlistx txth justlst ptstrlst interlist)
;	(mapcar '(lambda (x y z n) (if (not (eq "" z))
;		(drawtxt (if (eq y "bc") (ofstx x (/ n 2)) (ofstx x 1.5)) txth y z)
;		)) ptlistx justlst ptstrlst interlist
;	)
;)

(defun drawtxtptstrlst (ptlistx txth justlst ptstrlst interlist)
	(mapcar '(lambda (x y z n) (if (not (eq "" z))
		(drawtxt 
		
		;(if (eq y "bc") (ofstx x (/ n 2)) (ofstx x 1.5))
	
				(cond
					((eq y "bc") (ofstx x (/ n 2)))
					((eq y "br") (ofstx x (- n 1.5)))
					((eq y "bl") (ofstx x 1.5))
				)

		txth y z)
		)) ptlistx justlst ptstrlst interlist
	)
)



;           ,
;  .       
;  ( ) 
;(mdrtxt2 ptlistx txth justlist (cdr mlst) interlist theight)
(defun mdrtxt2 (ptlistx txth justlst str interlist theight)
	(while str
		(drawtxtptstrlst ptlistx txth justlst (car str) interlist)
		(setq ptlistx (mapcar '(lambda (x) (ofsty x theight)) ptlistx))
		(setq str (cdr str))
	)
)

;      
;(mdrtxt (cdr (gtable)))
(defun mdrtxt (str / adata)
	(while str
		(setq adata (cons (car (car str)) adata))	
		(setq str (cdr str))
	)
	(reverse adata)
)

;   
;  
(defun ucdr (lst)
	(reverse (cdr (reverse lst)))
)

;     N
;(setq a '(0 1 2 3 4 5))
;(ccdr 3 a)
(defun ccdr (n lst)
	(if (not (= 0 n)) (ccdr (1- n) (cdr lst)) lst))

;(draw_table (gtable))
(defun draw_table (mlst / justlst interlist theight txth frowh pt1 ptlistx ptlisty)

;   
(setq
	justlist (nth 2 mlst)
	;justlst '("bc" "bl" "bc" "bc" "bc" "bc");     	
	interlist (mapcar 'atof (nth 1 mlst))
	;interlist '(10.0 80.0 15.0 10.0);    
	theight (atoi (nth 1 (nth 0 mlst)))
	;theight 5;   (8   )
	txth (atof (vl-string-subst "." "," (nth 2 (nth 0 mlst))))
	;txth 3.5;   
	frowh (atoi (nth 0 (nth 0 mlst)))
	;frowh 10;    15   
	row_space 0.9;  ,   
	pt1 (getpoint "\nEnter start point: ");    
	ptlistx (cons pt1 (mkptxlist pt1 interlist));      
	ptlisty (cons pt1 (mkptylist (ofsty pt1 frowh) theight (length (ccdr 4 mlst))));      
)

;   
(draw_line ptlistx (/ pi -2)
	(eval (list '- (cadr (car ptlisty)) (cadr (last ptlisty)))))

;   
(draw_line ptlisty 0 (eval (cons '+ interlist))) 

;   
;(setq ptlistx2
;	(mapcar '(lambda (x y) (ofsty (ofstx x (/ y 2.0)) (/ frowh 2.0))) ptlistx interlist)
;)
;(mkmtxt (getpoint) 3 "mc" row_space 33 "teststring value")
(mapcar '(lambda (x y z) (mkmtxt
	(ofsty (ofstx x (/ y 2.0)) (/ frowh 2.0))
	txth "mc" row_space (- y 1.0) z))
	ptlistx interlist (nth 3 mlst)
)

;  
(mdrtxt2
	(mapcar '(lambda (x) (ofsty x (+ frowh theight))) (ucdr ptlistx))
	txth justlist (ccdr 4 mlst) interlist theight
)

(princ)
)

(defun c:dt-csv ( / old_osnap)
(vl-load-com)
;(load "readxls")
(load "readcsv")

;http://forum.dwg.ru/archive/index.php/t-31628.html
;    ?
;(if (eq fn nil)
;	(setq fn (getfiled "Select a spreadsheet file" "c:\\" "xls" 8))
;	(setq fn (getfiled "Select a spreadsheet file" (strcat (vl-filename-directory (findfile fn)) "\\") "xls" 8))
;)

;(eea-get_xl (getfiled "Select a spreadsheet file" "c:/work/lisp/test/" "xls" 8))

;(setq
;	xlsdata (eea-get_xl fn)
;	shlst (mapcar 'car xlsdata)
;)

(draw_table (gtable))

(command "_.undo" "_begin");    
(setq old_osnap (getvar "OSMODE"));  
(setvar "OSMODE" 0);   


; 
(setvar "OSMODE" old_osnap)

;   
(command "_.undo" "_end")
)
