(defun C:LTINC()(LTINC t))
(defun C:LTINCN()(LTINC nil))
(defun LTINC ( Only-number / layout_names layout_length old_layout_name new_layout_name last_layout_name buf i)
  ;;; Only-number
  ;;; if t , [a-z] [A-Z] characters are integrated to suffix
  ;;;            Example  "Drawing_A" -  "Drawing_B"
  ;;; if nil , increase only digit
  ;;;            Example  "Drawing_A" -  "Drawing_A-1"
  
  
    ;;http://dwg.ru/f/showthread.php?p=238661#post238661
    ;;=================================================================
    ;;         
    ;;
    ;;  LTINC |  2008 Vladimir Azarko (VVA) | All Rights Removed
    ;;  LTINC |  2008   (VVA) |   
    ;;
    ;;=================================================================
    ;;
    ;; *** : ***
    ;;
    ;;               .
    ;;
    ;;=================================================================================
    ;;
    ;; *** :  ***
    ;;
    ;;              .
    ;;      , -, 
    ;;   :
    ;;      (layout)     
    ;;        5                          6
    ;;       -1                       -2
    ;;       1.1                      1.2
    ;;                              
    ;;        (1)                   (2)
    ;;
    ;;            
    ;;  1:
    ;;       : "3" "4" "9" "11" "12"
    ;;   "9".    LAYINC     
    ;; "3" "4" "9" "10" "11" "12" (.   "10"   "9")
    ;;
    ;;  2:
    ;;       : "-3" "-4" "-9" "-10" "-11" "-13"
    ;;   "-9".    LAYINC     
    ;; "-3" "-4" "-9" "-10" "-11"  "-12" "-13" (.   "-12"    "-11"
    ;;     "-10" "-11"  )
    ;;
    ;;=================================================================================
    ;;
    ;; *** :  ***
    ;;
    ;; 
    ;;
    ;; *** :  ***
    ;;
    ;;        INCSUFF -Gilles Chanteau- 2008/01/15
    ;;   ;;;http://dwg.ru/f/showthread.php?t=19936
    ;;
    ;;=================================================================================
(vl-load-com)
  (setq layout_names (LAYOUTLIST))
  (setq old_layout_name (getvar "CTAB"))
  (if (member old_layout_name layout_names)
    (progn
      (setq new_layout_name old_layout_name
           last_layout_name new_layout_name
            buf "" i (strlen new_layout_name))
      (while (or
               (member
               (setq new_layout_name (incsuff new_layout_name 1 Only-number))
               layout_names
               )
               (null new_layout_name)
               )
        (if new_layout_name
          (setq last_layout_name new_layout_name)
          (progn
            (if (= 0 i)
            (setq buf "" new_layout_name (strcat old_layout_name "-0"))
            (setq buf (strcat buf  (substr old_layout_name (strlen old_layout_name)))
                  new_layout_name (substr old_layout_name 1  (setq i (1- i)))
                  )
              )
            )
          )
        )
      (setq new_layout_name (strcat new_layout_name buf))
      (setq i (vla-get-TabOrder (vla-item(vla-get-layouts(vla-get-activedocument
      (vlax-get-acad-object))) last_layout_name)))
      (command "_.LAYOUT" "_C" old_layout_name new_layout_name)
;;;      (vla-put-TabOrder (vla-item(vla-get-layouts(vla-get-activedocument
;;;      (vlax-get-acad-object))) new_layout_name)(length (layoutlist)))
(vla-put-TabOrder (vla-item(vla-get-layouts(vla-get-activedocument
      (vlax-get-acad-object))) new_layout_name) (1+ i))
;;;(vla-put-TabOrder (vla-item(vla-get-layouts(vla-get-activedocument
;;;      (vlax-get-acad-object))) new_layout_name)
;;;  (1+(vla-get-TabOrder (vla-item(vla-get-layouts(vla-get-activedocument
;;;      (vlax-get-acad-object))) last_layout_name)))
;;;  )
      
      (setvar "CTAB" new_layout_name)
    )
    (alert (if(= (getvar "DWGCODEPAGE") "ANSI_1251") "   "  "Go to layout"))
  )
  (princ)
)
(defun C:LTREN ()(LTREN t))
(defun C:LTRENN ()(LTREN nil))
(defun LTREN ( Only-number / ret pat i ret1)
  ;;; Only-number
  ;;; if t , [a-z] [A-Z] characters are integrated to suffix
  ;;;            Example  "Drawing_A" -  "Drawing_B"
  ;;; if nil , increase only digit
  ;;;            Example  "Drawing_A" -  "Drawing_A-1"
  
    ;;=================================================================
    ;;   
    ;;
    ;;  LTREN |  2008 Vladimir Azarko (VVA) | All Rights Removed
    ;;  LTREN |  2008   (VVA) |   
    ;;
    ;;=================================================================
    ;;
    ;; *** : ***
    ;;
    ;;      
    ;;    
    ;;
    ;;=================================================================
 (vl-load-com)
  (if (setq ret
       (_dwgru-get-user-dcl
              (if(= (getvar "DWGCODEPAGE") "ANSI_1251") " " "Layuot rename")
              (mapcar 'vla-get-name (cdr(dwgru-layouts-list nil)))
             t
              ) ;_ end of _dwgru-get-user-dcl
      ) ;_ end of setq
    (progn
    (while (or (= "" (setq pat (vl-string-trim " \t\n" (getstring t
                                                       (if(= (getvar "DWGCODEPAGE") "ANSI_1251")  
                                                          "\n   (6, -6, -  ..) : "
                                                         "\nFirst number of layout (6, G-6, List-A and so on) : "
                                                         )))))
               (not(snvalid pat))
               )
      (princ (if(= (getvar "DWGCODEPAGE") "ANSI_1251") " *  *" " * Incorrect *"))
      )
    (setq ret (mapcar 'strcase ret))
    (setq lst (mapcar 'strcase (layoutlist)))
    (mapcar '(lambda(x)(setq lst (vl-remove x lst))) ret)
    (setq ret (mapcar '(lambda(x / y)
                         (setq y (strcat x "DWG.RU0"))
                         (while (member (setq y (incsuff y 1 t)) (mapcar 'strcase (layoutlist))))
                         (vla-put-name (vla-item(vla-get-layouts(vla-get-activedocument
                         (vlax-get-acad-object))) x) y)
                         y
                         )
                      ret
                   )
          )
    (setq i '-1)
    (setq ret1 (mapcar '(lambda(x)(incsuff pat (setq i (1+ i)) Only-number)) ret))
    (mapcar '(lambda(x  / y)
               (if (member x lst)
                 (progn
                   (setq y (strcat x "-$0"))
                   (while (member (setq y (incsuff y 1 t)) lst))
                   (vla-put-name (vla-item(vla-get-layouts(vla-get-activedocument
                   (vlax-get-acad-object))) x) y)
                   )
                 )
               x
               )
            ret1
            )
    (mapcar '(lambda( x y)
               (vla-put-name (vla-item(vla-get-layouts(vla-get-activedocument
                   (vlax-get-acad-object))) x) y)
               x
               )
            ret ret1
            )
    )
    )
  (princ)
) ;_ end of defun
;;LayuoT Rename and Sort
(defun C:LTRS ( )(c:LTREN)(C:LTSORTN))
(defun C:LTSORTN ()(LTSORT t))
(defun C:LTSORTA ()(LTSORT nil))
(defun LTSORT ( tip  / lst i)
    ;;=================================================================
    ;;    
    ;;
    ;;  LTSORT |  2008 Vladimir Azarko (VVA) | All Rights Removed
    ;;  LTSORT |  2008   (VVA) |   
    ;;
    ;;=================================================================
    ;;
    ;; tip - t -  ,        ( L1 L2 L3 L22)
    ;; tip - nil -       ( L1 L2 L22 L3)
  
    ;; *** : ***
    ;;
    ;;          .
    ;;         
    ;;
    ;;=================================================================
 (vl-load-com)
 (princ "Working ...") 
 (setq lst (if tip (SortStringWithNumberAsNumber (layoutlist) t)
                   (acad_strlsort (mapcar 'strcase (layoutlist))))
       i (length lst)
       )
 (foreach item (reverse lst)
   (vla-put-TabOrder (vla-item (vla-get-layouts(vla-get-activedocument
      (vlax-get-acad-object))) item) i)
   (setq i (1- i))
  )
  (princ " Done")
  (princ)
 )
;;;Layout switch
;;;http://dwg.ru/f/showthread.php?t=168...=layout&page=2
(defun c:LS ( / ret)
    ;;=================================================================
    ;;     
    ;;
    ;;  LS |  2008 Vladimir Azarko (VVA) | All Rights Removed
    ;;  LS |  2008   (VVA) |   
    ;;
    ;;=================================================================
    ;;
    ;; *** : ***
    ;;
    ;;        
    ;;      -   
    ;;
    ;;=================================================================
  
 (vl-load-com)
  (and
    (setq
      ret
       (car (_dwgru-get-user-dcl
              (if(= (getvar "DWGCODEPAGE") "ANSI_1251") " " "Select layuot")
              (mapcar 'vla-get-name (cdr(dwgru-layouts-list nil)))
              nil
              ) ;_ end of _dwgru-get-user-dcl
            ) ;_ end of car
      ) ;_ end of setq
    (setvar "CTAB" ret)
    ) ;_ end of and
  (princ)
  ) ;_ end of defun


(defun dwgru-layouts-list (doc)
  (or doc (setq doc (vla-get-activedocument (vlax-get-acad-object))))
  (vl-sort
    ((lambda (/ res)
       (vlax-for item (vla-get-Layouts doc)
         (setq res (cons item res))
         ) ;_ end of vlax-for
       ) ;_ end of lambda
     )
        
    '(lambda (a b)
       (< (vla-get-taborder a) (vla-get-taborder b))
       ) ;_ end of lambda
    ) ;_ end of vl-sort
  ) ;_ end of defun

;;; RUS ************************************************************************
;;; *  DWGruLispLib Copyright 2008  DWGru Programmers Group
;;; *
;;; * _dwgru-get-user-dcl ()
;;; *
;;; *       
;;; *
;;; *
;;; * 26/01/2008  0002.    (VVA)
;;;              -    ,     (multi-nil)
;;;              -   
;;; * 21/01/2008  0001.    (VVA)
;;; ************************************************************************


;;; EN ************************************************************************
;;; * Library DWGruLispLib Copyright  2008 DWGru Programmers Group
;;; *
;;; * _dwgru-get-user-dcl (Candidate)
;;; *
;;; * Inquiry of value at the user through a dialogue window
;;; *
;;; *
;;; * 26/01/2008 Version 0002. Edition Vladimir Azarko (VVA)
;;; - the Output on double a clique if the plural choice (multi-nil) is forbidden
;;; - Processing of several columns
;;; * 21/01/2008 Version 0001. Edition Vladimir Azarko (VVA)


(defun _DWGRU-GET-USER-DCL (ZAGL        INFO-LIST   MULTI
                            /           FL          RET
                            DCL_ID      MAXROW      MAX_COUNT_COL
                            COUNT_COL   I           LISTBOX_HEIGHT
                            LST         _LOC_FINISH _LOC_CLEAR
                            NCOL
                           )
;|
* ENGLISH
* Inquiry of value at the user through a dialogue window
* Dialogue is formed to "strike"
* the Quantity of lines on page without  is set by variable MAXROW.
* It is necessary to remember, that number MAXROW increases on 3.
* the Maximum quantity of columns is set by variable MAX_COUNT_COL
* It is published
     http://dwg.ru/f/showthread.php?p=203746#post203746
* Parameters of a call:
    zagl - heading of a window [String]
    info-list - the list of line values [List of String]
    multi - t - the plural choice is resolved, nil-is not present
      
* Returns:
 The list of the chosen lines or nil - a cancelling
* the Example
 (_dwgru-get-user-dcl " Specify a variant " ' ("First " Second " " Third ") nil); _-> ("First") 
 (_dwgru-get-user-dcl " Specify a variant " ' ("First " Second " " Third ") t); _-> ("First " Second ")
 (_dwgru-get-user-dcl " Specify a variant "
   (progn (setq i 0 lst nil) (repeat 205 (setq lst (cons (strcat "-" (itoa (setq i (1+ i)))) lst))) (reverse lst)) nil)
 (_dwgru-get-user-dcl " Specify a variant, using CTRL and SHIFT for a choice "
   (progn (setq i 0 lst nil) (repeat 205 (setq lst (cons (strcat "-" (itoa (setq i (1+ i)))) lst))) (reverse lst)) t)
|;
						   
						   
;|
* RUS						   
*       
*   ""
*         MAXROW.
*  ,   MAXROW   3.
*      MAX_COUNT_COL
* 
     http://dwg.ru/f/showthread.php?p=203746#post203746
*  :
    zagl -   [String]
    info-list -    [List of String]
    multi - t -   , nil- 
    
* :
     nil - 
* 
 (_dwgru-get-user-dcl " " '("" "" "") nil) ;_->("") 
 (_dwgru-get-user-dcl " " '("" "" "") t) ;_->("" "")
 (_dwgru-get-user-dcl " "
   (progn (setq i 0 lst nil)(repeat 205 (setq lst (cons (strcat "-" (itoa (setq i (1+ i)))) lst)))(reverse lst)) nil)
 (_dwgru-get-user-dcl " ,  CTRL  SHIFT  "
   (progn (setq i 0 lst nil)(repeat 205 (setq lst (cons (strcat "-" (itoa (setq i (1+ i)))) lst)))(reverse lst)) t)
|;
 ;_ =====  ============

  (setq MAXROW 40) ;_c. -    (     3 )
                   ;_  max lines without scrolling (To it 3 more lines further will be added)
  (setq MAX_COUNT_COL 5) ;_  
                         ;_ ; _ a maximum quantity of columns

;;;====================   START==================================
;;;==================== Local functions START==================================

  (defun _LOC_FINISH ()
    (setq I   0
          RET NIL
    ) ;_ end ofsetq
    (repeat COUNT_COL
      (setq I (1+ I))
      (setq RET (cons (cons I (get_tile (strcat "info" (itoa I)))) RET))
    ) ;_ end ofrepeat
    (setq RET (reverse RET))
    (done_dialog 1)
  ) ;_ end ofdefun
  (defun _LOC_CLEAR (NOMER)
    (setq I 0)
    (repeat COUNT_COL
      (setq I (1+ I))
      (if (/= I NOMER)
        (progn
          (start_list (strcat "info" (itoa I)))
          (mapcar 'add_list (nth (1- I) LST))
          (end_list)
        ) ;_ end ofprogn
      ) ;_ end ofif
    ) ;_ end ofrepeat
  ) ;_ end ofdefun

;;;====================   END ==================================
;;;==================== Local functions END ==================================

;;;==================== MAIN PART ===============================================

  (if (null ZAGL)
    (if (= (getvar "DWGCODEPAGE") "ANSI_1251")
      (setq ZAGL "")
      (setq ZAGL "Select")
    ) ;_ end ofif
  ) ;_ end if
  (if (zerop (rem (length INFO-LIST) MAXROW)) ;_  
    (setq COUNT_COL (/ (length INFO-LIST) MAXROW)) ;_  
    (setq COUNT_COL (1+ (fix (/ (length INFO-LIST) MAXROW 1.0)))) ;_  
  ) ;_ end ofif
  (if (> COUNT_COL MAX_COUNT_COL)
    (setq COUNT_COL MAX_COUNT_COL)
  ) ;_ max 
  (setq LISTBOX_HEIGHT (+ 3 MAXROW)) ;_   3        
                                     ;_ We add 3 lines for appearance and for exception boundary scroll
  (if (and (= COUNT_COL 1) (<= (length INFO-LIST) MAXROW))
    (setq LISTBOX_HEIGHT (+ 3 (length INFO-LIST)))
  ) ;_ end ofif
  (setq I 0)
  (setq FL (vl-filename-mktemp "dwgru" NIL ".dcl"))
  (setq RET (open FL "w")
        LST NIL
  ) ;_ end ofsetq
  (mapcar '(lambda (X) (write-line X RET))
          (append (list "dwgru_get_user : dialog { "
                        (strcat "label=\"" ZAGL "\";")
                        ": boxed_row {"
                        (if (= (getvar "DWGCODEPAGE") "ANSI_1251")
                          "label = \"\";"
                          "label = \"Value\";"
                        ) ;_ end ofif
                  ) ;_ end oflist
                  (repeat COUNT_COL
                    (setq LST
                           (append
                             LST
                             (list
                               " :list_box {"
                               "alignment=top ;"
                               (if MULTI
                                 "multiple_select = true ;"
                                 "multiple_select = false ;"
                               ) ;_ end ofif
                               "width=31 ;"
                               (strcat "height= " (itoa LISTBOX_HEIGHT) " ;")
                               "is_tab_stop = false ;"
                               (strcat "key = \"info" (itoa (setq I (1+ I))) "\";}")
                             ) ;_ end oflist
                           ) ;_ end ofappend
                    ) ;_ end ofsetq
                  ) ;_ end ofrepeat
                  (list
                    "}"
                    ":row{"
                    "ok_cancel_err;}}"
                  ) ;_ end oflist
          ) ;_ end of list
  ) ;_ end of mapcar
  (setq RET (close RET))
  (if (and (null (minusp (setq DCL_ID (load_dialog FL))))
           (new_dialog "dwgru_get_user" DCL_ID)
      ) ;_ end and
    (progn
      (setq LST INFO-LIST)
      ((lambda (/ RET1 BUF ITM)

         (repeat (1- COUNT_COL)
           (setq I '-1)
           (while (and (setq ITM (car LST))
                       (< (setq I (1+ I)) MAXROW)
                  ) ;_ end ofand
             (setq BUF (cons ITM BUF)
                   LST (cdr LST)
             ) ;_ end ofsetq
           ) ;_ end ofwhile
           (setq RET1 (cons (reverse BUF) RET1)
                 BUF  NIL
           ) ;_ end ofsetq
         ) ;_ end ofrepeat
         (setq RET RET1)
       ) ;_ end oflambda
      )
      (if LST
        (setq RET (cons LST RET))
      ) ;_ end ofif
      (setq LST (reverse RET))
      (setq I 0)
      (mapcar '(lambda (THIS_LIST)
                 (if (<= (setq I (1+ I)) COUNT_COL)
                   (progn
                     (start_list (strcat "info" (itoa I)))
                     (mapcar 'add_list THIS_LIST)
                     (end_list)
                   ) ;_ end ofprogn
                 ) ;_ end ofif
               ) ;_ end oflambda
              LST
      ) ;_ end ofmapcar

      (set_tile "info1" "0")
      (setq I 0
            NCOL 1
      ) ;_ end ofsetq
      (repeat COUNT_COL
        (action_tile
          (strcat "info" (itoa (setq I (1+ I))))
          (strcat "(progn (setq Ncol "
                  (itoa I)
                  ")(if (not multi)(_loc_clear Ncol))"
                  "(if (and (not multi)(= $reason 4))(_loc_finish)))"
          ) ;_ end ofstrcat
        ) ;_ end ofaction_tile
      ) ;_ end ofrepeat
      (action_tile "cancel" "(done_dialog 0)")
      (action_tile "accept" "(_loc_finish)")
      (if MULTI
        (set_tile "error"
                  (if (= (getvar "DWGCODEPAGE") "ANSI_1251")
                    " CTRL  SHIFT  "
                    "Use CTRL and SHIFT for a choicet"
                  ) ;_ end ofif
        ) ;_ end ofset_tile
        (set_tile "error"
                  (if (= (getvar "DWGCODEPAGE") "ANSI_1251")
                    "   "
                    "It is possible to choose double click"
                  ) ;_ end ofif
        ) ;_ end ofset_tile
      ) ;_ end ofif
      (if (zerop (start_dialog))
        (setq RET NIL)
        (progn
          (setq
            RET (apply
                  'append
                  (mapcar
                    '(lambda (ITM)
                       (setq THIS_LIST (nth (1- (car ITM)) LST))
                       (mapcar
                         (function (lambda (NUM) (nth NUM THIS_LIST)))
                         (read (strcat "(" (cdr ITM) ")"))
                       ) ;_ end ofmapcar
                     ) ;_ end oflambda
                    RET
                  ) ;_ end ofmapcar
                ) ;_ end ofapply
          ) ;_ end ofsetq

        ) ;_ end ofprogn
      ) ;_ end if
      (unload_dialog DCL_ID)
    ) ;_ end of progn
  ) ;_ end of if
  (vl-file-delete FL)
  RET
) ;_ end of defun


(defun incsuff (str inc alpha / lst crt pas ind dep quo ret)
;; INCSUFF -Gilles Chanteau- 2008/01/15
;; Adds the specified increment to a string suffix.
;; Is considered as suffix, all [0-9] characters from the end of the string
;; more [A-Z] and [a-z] characters if alpha argument is non nil.
;;
;; Adapting to the Russian alphabet by VVA (Vladimir Azarko)  
;; Arguments
;; str : a string
;; inc : a positive integer
;; alpha : if non nil, [a-z] [A-Z] characters are integrated to suffix.
;;
;; Return
;; The string with incremented suffix (or nil if none valid suffix)
;;
;; Examples :
;; (incsuff "N 002" 12 T) = "N 014"
;; (incsuff "Drawing_A" 1 T) = "Drawing_B"
;; (incsuff "test_ZZ9" 1 T) = "test_AAA0"
;; (incsuff "test_ZZ9" 1 nil) = "test_ZZ10"
;; (incsuff "12-" 1 nil) = nil  
  
  (setq lst (reverse (vl-string->list str)))
  (while
    (and
      (setq crt (car lst))
      (cond
        ((< 47 crt 58) ;_Number
         (setq pas 10  ;_Step
               ind 48  ;_ ASCII Code Number 0
         ) ;_ end of setq
        )
        ((and alpha (< 64 crt 91)) ;_Upper case latin
         (setq pas 26              ;_Number of letters in the alphabet (step)
               ind 65              ;_Upper case latin A (eng)
         ) ;_ end of setq
        )
        ((and alpha (< 96 crt 123)) ;_Lower case latin
         (setq pas 26               ;_Number of letters in the alphabet (step)
               ind 97               ;_Lower case latin A (eng)
         ) ;_ end of setq
        )
        ((and alpha (< 191 crt 224));_Upper case russian
         (setq pas 32               ;_Number of letters in the alphabet (step)
               ind 192              ;_Upper case russian A
         ) ;_ end of setq
        )
        ((and alpha (< 223 crt 256));_Lower case russian
         (setq pas 32               ;_Number of letters in the alphabet (step)
               ind 224              ;_Lower case russian A
         ) ;_ end of setq
        )
        ((< 0 quo)
         (setq crt (if (= 10 pas)
                     ind
                     (1- ind)
                   ) ;_ end of if
               lst (cons (car lst) lst)
         ) ;_ end of setq
        )
      ) ;_ end of cond
    ) ;_ end of and
     (setq dep (- crt ind)
           quo (/ (+ dep inc) pas)
           ret (cons (+ ind (rem (+ dep inc) pas)) ret)
     ) ;_ end of setq
     (if (zerop quo)
       (setq ret (append (reverse (cdr lst)) ret)
             lst nil
       ) ;_ end of setq
       (if (cdr lst)
         (setq lst (cdr lst)
               inc quo
         ) ;_ end of setq
         (setq lst (list ind)
               inc (if (= 10 pas)
                     quo
                     (1- quo)
                   ) ;_ end of if
         ) ;_ end of setq
       ) ;_ end of if
     ) ;_ end of if
  ) ;_ end of while
  (if ret
    (vl-list->string ret)
  ) ;_ end of if
) ;_ end of defun


;; INCSUFF -Gilles Chanteau- 2008/01/15
;; Adds the specified increment to a string suffix.
;; Is considered as suffix, all [0-9] characters from the end of the string
;; more [A-Z] and [a-z] characters if alpha argument is non nil.
;;
;; Arguments
;; str : a string
;; inc : a positive integer
;; alpha : if non nil, [a-z] [A-Z] characters are integrated to suffix.
;;
;; Return
;; The string with incremented suffix (or nil if none valid suffix)
;;
;; Examples :
;; (incsuff "N 002" 12 T) = "N 014"
;; (incsuff "Drawing_A" 1 T) = "Drawing_B"
;; (incsuff "test_ZZ9" 1 T) = "test_AAA0"
;; (incsuff "test_ZZ9" 1 nil) = "test_ZZ10"
;; (incsuff "12-" 1 nil) = nil  
;;;(defun incsuff (str inc alpha / lst crt pas ind dep quo ret)
;;;  (setq lst (reverse (vl-string->list str)))
;;;  (while
;;;    (and
;;;      (setq crt (car lst))
;;;      (cond
;;;        ((< 47 crt 58) ;_
;;;         (setq pas 10  ;_-  ()
;;;               ind 48  ;_  0
;;;         ) ;_ end of setq
;;;        )
;;;        ((and alpha (< 64 crt 91)) ;_  
;;;         (setq pas 26              ;_-    ()
;;;               ind 65              ;_  A ()
;;;         ) ;_ end of setq
;;;        )
;;;        ((and alpha (< 96 crt 123)) ;_  
;;;         (setq pas 26               ;_-    ()
;;;               ind 97               ;_  a ()
;;;         ) ;_ end of setq
;;;        )
;;;        ((and alpha (< 191 crt 224));_  
;;;         (setq pas 32               ;_-    ()
;;;               ind 192              ;_  a ()
;;;         ) ;_ end of setq
;;;        )
;;;        ((and alpha (< 223 crt 256));_  
;;;         (setq pas 32               ;_-    ()
;;;               ind 224              ;_  a ()
;;;         ) ;_ end of setq
;;;        )
;;;        ((< 0 quo)
;;;         (setq crt (if (= 10 pas)
;;;                     ind
;;;                     (1- ind)
;;;                   ) ;_ end of if
;;;               lst (cons (car lst) lst)
;;;         ) ;_ end of setq
;;;        )
;;;      ) ;_ end of cond
;;;    ) ;_ end of and
;;;     (setq dep (- crt ind)
;;;           quo (/ (+ dep inc) pas)
;;;           ret (cons (+ ind (rem (+ dep inc) pas)) ret)
;;;     ) ;_ end of setq
;;;     (if (zerop quo)
;;;       (setq ret (append (reverse (cdr lst)) ret)
;;;             lst nil
;;;       ) ;_ end of setq
;;;       (if (cdr lst)
;;;         (setq lst (cdr lst)
;;;               inc quo
;;;         ) ;_ end of setq
;;;         (setq lst (list ind)
;;;               inc (if (= 10 pas)
;;;                     quo
;;;                     (1- quo)
;;;                   ) ;_ end of if
;;;         ) ;_ end of setq
;;;       ) ;_ end of if
;;;     ) ;_ end of if
;;;  ) ;_ end of while
;;;  (if ret
;;;    (vl-list->string ret)
;;;  ) ;_ end of if
;;;) ;_ end of defun

;;;Published http://www.theswamp.org/index.php?topic=16564.0
(defun SortStringWithNumberAsNumber (ListOfString IgnoreCase / NorStrs count)
;;;Function Normalize (add 0 befor number) number in string
;;; Count normalize symbols set in variable count
;;; CAB added count as an argument
  (defun NormalizeNumberInString (str count / ch i pat ret buf)
    (setq i   0
          pat '("0" "1" "2" "3" "4" "5" "6" "7" "8" "9")
          ret ""
    ) ;_ end of setq
    (while (/= (setq ch (substr str (setq i (1+ i)) 1)) "")
      (if (vl-position ch pat)
        (progn
          (setq buf ch) ;_ end of setq
          (while
            (vl-position (setq ch (substr str (setq i (1+ i)) 1)) pat)
             (setq buf (strcat buf ch))
          ) ;_ end of while
          (while (< (strlen buf) count) (setq buf (strcat "0" buf)))
          (setq ret (strcat ret buf))
        ) ;_ end of progn
      ) ;_ end of if
      (setq ret (strcat ret ch))
    ) ;_ end of while
    ret
  ) ;_ end of defun
  ;;-------------------------------------------------
  ;;  function to Count the longest number in string 
  ;;  CAB added to get the correct COUNT
  (defun getcount (lst / count pat)
    (setq count 0)
    (setq pat '("0" "1" "2" "3" "4" "5" "6" "7" "8" "9"))
    (mapcar
      '(lambda (str / i maxlen ch)
         (setq i 0 maxlen 0)
         (while (/= (setq ch (substr str (setq i (1+ i)) 1)) "")
           (if (vl-position ch pat) ; number
             (setq maxlen (1+ maxlen))
             (setq count  (max count maxlen) maxlen 0)
           )
         )
	 (setq count  (max count maxlen)) ;_<<< ADD 21.06.2007 by 
       )
      Lst
    )
    count
  )
  ;;===============================================
  (setq count   (GetCount ListOfString)
        NorStrs (mapcar '(lambda (x) (NormalizeNumberInString x count))
                        ListOfString)
  )
  (and IgnoreCase (setq NorStrs (mapcar 'strcase NorStrs)))
  (mapcar '(lambda (x) (nth x ListOfString)) (vl-sort-i NorStrs '<))
)
(if(= (getvar "DWGCODEPAGE") "ANSI_1251")
(progn  
(princ "\n :")
(princ "\nLTINC -        ,   (Drawing_A ->  Drawing_B)")
(princ "\nLTINCN -         (Drawing_A9 ->  Drawing_A10)")
(princ "\nLTREN -        ,   ( Drawing_A ->  Drawing_B)")
(princ "\nLTRENN -         (Drawing_A9 ->  Drawing_A10)")
(princ "\nLTSORTN -      (L1 L2 L3 L22)")
(princ "\nLTSORTA -      (L1 L2 L22 L3)")
(princ "\nLS     -    ")
(princ "\nLTRS   -     ")
)
  (progn
(princ "\nType in command line:")
(princ "\nLTINC - Copy and increment current layout including letters (Drawing_A-> Drawing_B) ")
(princ "\nLTINCN - Copy and increment DIGITAL number current layout  (Drawing_A9-> Drawing_A10)")
(princ "\nLTREN - Rename selected layout including letters (Drawing_A-> Drawing_B)")
(princ "\nLTRENN - Rename selected layout and increment its DIGITAL number (Drawing_A9-> Drawing_A10)")
(princ "\nLTSORTN - Layout sort as numeric (L1 L2 L3 L22)")
(princ "\nLTSORTA - Layout sort as alphabetic (L1 L2 L22 L3)")
(princ "\nLS     - Layout switch")
(princ "\nLTRS   - Rename and sort as numeric" )
    )
  )
