(defun GetVertexList (entlist / vertlist coords)
  (vl-load-com)
  (setq vertlist (member (assoc 10 entlist) entlist))
  (repeat (cdr (assoc 90 entlist))
    (setq coords   (cons (cdar vertlist) coords)
	  vertlist (cddddr vertlist)
    )
  )
  (reverse coords)
)

(defun Poly-Pts	(pl / pa pt lst)
  (vl-load-com)
  (setq	pa (if (vlax-curve-IsClosed pl)
	     (vlax-curve-getEndParam pl)
	     (+ (vlax-curve-getEndParam pl) 1)
	   )
  )
  (while (setq pt (vlax-curve-getPointAtParam pl (setq pa (- pa 1))))
    (setq lst (cons pt lst))
  )
)

(defun c:pline_params (/)
  (vl-load-com)
  (setq _ce (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  
  (setq pline (entsel "\n :"))
  (setq ptlst (Poly-Pts (vlax-ename->vla-object (car pline))))
  ;;(setq ptlst (GetVertexList (entget (car pline))))
  (setq count (length ptlst))
  (setq	i 1
	n 0
	m 0
	k 0
	s 0
	h 0
	j 0
	f 0
	ListX (list)
	ListY (list)
	ListLen	(list)
	ListIx (list)
	ListIy (list)
	summXLen 0
	summYlen 0
	summLen	0
	summListIx_cp
	 0
	summListIy_cp
	 0
	cp (list)
  )
  (if (and (= (cdr (assoc 70 (entget (car pline)))) 1)
	   (not (equal (nth 0 ptlst) (nth (1- count) ptlst)))
      )
    (progn
      (princ "closed")
      (setq ptlst (append ptlst (list (nth 0 ptlst)))
	    count (1+ count)
      )
      (princ ptlst)
    )
  )
  (while (<= i (1- count))
    (setq x_cp	 (/ (+ (car (nth i ptlst)) (car (nth (1- i) ptlst))) 2)
	  y_cp	 (/ (+ (cadr (nth i ptlst)) (cadr (nth (1- i) ptlst))) 2)
	  deltaX (- (car (nth i ptlst)) (car (nth (1- i) ptlst)))
	  deltaY (- (cadr (nth i ptlst)) (cadr (nth (1- i) ptlst)))
	  len	 (sqrt
		   (+ (expt deltaX 2)
		      (expt deltaY 2)
		   )
		 )
	  )
    (setq
	  Ix	 (/ (* len (expt deltaY 2)) 12)
	  Iy	 (/ (* len (expt deltaX 2)) 12)
    )
    (setq cp_temp (list x_cp y_cp 0))
    (setq ListX	  (append ListX (list x_cp))
	  ListY	  (append ListY (list y_cp))
	  ListLen (append ListLen (list len))
	  ListIx  (append ListIx (list Ix))
	  ListIy  (append ListIy (list Iy))
    )
    (setq i (1+ i))
  )
  (setq	multXLen (mapcar '* ListX ListLen)
	multYLen (mapcar '* ListY ListLen)
  )
  (foreach n multXLen (setq summXLen (+ summXLen n)))
  (foreach m multYLen (setq summYLen (+ summYLen m)))
  (foreach k ListLen (setq summLen (+ summLen k)))
  (setq	res_X_cp (/ summXLen summLen)
	res_Y_cp (/ summYLen summLen)
	cp	 (list res_X_cp res_Y_cp 0)
  )

  (setq
    ListIx_cp
	      (mapcar '+
		      (mapcar
			'*
			ListLen
			(mapcar
			  '*
			  (mapcar (function (lambda (x) (- x res_Y_cp))) ListY)
			  (mapcar (function (lambda (x) (- x res_Y_cp))) ListY)
			)
		      )
		      ListIx
	      )
    ListIy_cp
	      (mapcar '+
		      (mapcar
			'*
			ListLen
			(mapcar
			  '*
			  (mapcar (function (lambda (x) (- x res_X_cp))) ListX)
			  (mapcar (function (lambda (x) (- x res_X_cp))) ListX)
			)
		      )
		      ListIy
	      )
  )
  (setq	Lx 0
	Ly 0
  )
  (foreach s ListX
    (if	(> (abs (- s res_X_cp)) Lx)
      (setq Lx (abs (- s res_X_cp)))
    )
  )
  (foreach h ListY
    (if	(> (abs (- h res_Y_cp)) Ly)
      (setq Ly (abs (- h res_Y_cp)))
    )
  )
  (foreach j ListIx_cp
    (setq summListIx_cp (+ summListIx_cp j))
  )
  (foreach f ListIy_cp
    (setq summListIy_cp (+ summListIy_cp f))
  )
  (princ (strcat "\n    X:"
		 (rtos summListIx_cp)
	 )
  )
  (princ (strcat "\n    Y:"
		 (rtos summListIy_cp)
	 )
  )
   (princ (strcat "\n    X:"
		 (rtos (/ summListIx_cp Ly))
	 )
  )
  (princ (strcat "\n    Y:"
		 (rtos (/ summListIy_cp Lx))
	 )
  )
  (command "._point" cp)

  (setvar "cmdecho" _ce)
  (princ)
)