(defun c:put-dist-2
			    (/		   make_hod_rec	 LWp
			     temp	   adoc		 dist
;;;;;;;;;;;;;;;;;;;;;;;
			     make_hod_rec  make_spline	 add_midl_rec
			     midl_point	   make_lwp	 makedoublesafe
			     geo_vibor
			    )
;;;;;;
;;;;;;make_hod_rec
;;;;;;
  (defun make_hod_rec (_list	    /		 AngleVertexP
		       FirstEndP    SecondEndP	 TextP
		      )
    (cond      
      ((>= (length _list) 2)
       (setq
	 FirstEndP  (car _list)
	 SecondEndP (cadr _list)
	 TextP	    (polar
		      FirstEndP
		      (+ (angle FirstEndP SecondEndP)
			 (/ pi 2)
		      )
		      user_dist_for_put_angle
		    )
       )
       (vla-AddDimAligned
	 (vla-get-modelspace adoc)
	 (vlax-3d-point FirstEndP)
	 (vlax-3d-point SecondEndP)
	 (vlax-3d-point TextP)
       )      
      (make_hod_rec (cdr _list)))
      (t t)
    )
  )

;;;
;;;add_midl_rec
;;;
  (defun add_midl_rec (_list / st-P en_p)
    (cond
      ((cadr _list)
       (setq st-P (car _list)
	     en_p (cadr _list)
       )
       (cons
	 st-P
	 (cons
	   (mapcar (function (lambda (x y) (/ (+ x y) 2.0)))
		   st-P
		   en_p
	   )
	   (add_midl_rec (cdr _list))
	 )
       )
      )
      (t _list)
    )
  )




 
;;;
;;;geo_vibor
;;;
(defun geo_vibor (zap tip sloy exit_ / flag name ru)
  (setq	Flag t
	ru   (= (getvar "SysCodePage") "ANSI_1251")
  )
  (setvar "ERRNO" 0)
  (while Flag
    (setq name
	   (car (entsel zap))
    )
    (cond
					;
      ((and exit_ (= (getvar "ERRNO") 52))
       (setq Flag nil)
      )
      ((not name)
       (princ (if ru
		"\n :( "
		"\nMiss :( "
	      )
       )
      )
					;
      ((not
	 (wcmatch (cdr (assoc 0 (entget name)))
		  tip
	 )
       )
       (princ
	 (strcat
	   (if ru
	     "\n   ,  : "
	     "\n Bad object that must be: "
	   )
	   tip
	 )
       )
      )
					;
      ((not
	 (wcmatch (cdr (assoc 8 (entget name)))
		  sloy
	 )
       )
       (princ
	 (strcat
	   (if ru
	     "\n     ,   "
	     "\nSelected object not on the right layer, must be "
	   )
	   sloy
	 )
       )
      )
					;
      (t
       (setq Flag nil
	     name name
       )
      )
					;
    )
  )
)

;;;
;;;group-by-num
;;;
(defun group-by-num (lst num / ls ret)
  (if (= (rem (length lst) num) 0)
    (progn
      (setq ls nil)
      (repeat (/ (length lst) num)
	(repeat	num
	  (setq	ls
		    (cons (car lst) ls)
		lst (cdr lst)
	  )
	)
	(setq ret (append ret (list (reverse ls)))
	      ls  nil
	)
      )
    )
  )
  ret
)
;;;;;;;;;;;;;;;;;;;;;;;;  
  (vl-load-com)
  (initget 7)
  (setq user_dist_for_put_angle
	     (getdist
		     
			"\n  <"
			
		      
	     ))
  (While (setq LWp
	     (geo_vibor
	       "\n () <>: "
	       "LWPOLYLINE"
	       "*"
	       t
	     )
      )
    (progn
      (or user_dist_for_put_angle
	  (setq user_dist_for_put_angle 20)
      )
      (setq
	point_list
	 (group-by-num
	   (vlax-get
	     (vlax-ename->vla-object
	       LWp
	     )
	     'Coordinates
	   )
	   2
	 )
	adoc (vla-get-activedocument
	       (vlax-get-acad-object)
	     )
	point_list (add_midl_rec
;;;		     (append
		       point_list
;;;		       (list(car point_list))
;;;		       )
	)
      )
      (vla-startundomark adoc)
      (make_hod_rec point_list)
      (vla-endundomark adoc)
    )
  )
)


