;; ==================================================================== ;;
;;                                                                      ;;
;;  RENLAY.LSP - Allows to rename layers quickly without Layer Manager. ;;
;;                                                                      ;;
;; ==================================================================== ;;
;;                                                                      ;;
;;  Command(s) to call: RENLAY                                          ;;
;;                                                                      ;;
;;  Select entity on wanted layer and rename it.                        ;;
;;                                                                      ;;
;; ==================================================================== ;;
;;                                                                      ;;
;;  THIS PROGRAM AND PARTS OF IT MAY REPRODUCED BY ANY METHOD ON ANY    ;;
;;  MEDIUM FOR ANY REASON. YOU CAN USE OR MODIFY THIS PROGRAM OR        ;;
;;  PARTS OF IT ABSOLUTELY FREE.                                        ;;
;;                                                                      ;;
;;  THIS PROGRAM PROVIDES 'AS IS' WITH ALL FAULTS AND SPECIFICALLY      ;;
;;  DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS        ;;
;;  FOR A PARTICULAR USE.                                               ;;
;;                                                                      ;;
;; ==================================================================== ;;
;;                                                                      ;;
;;  V1.0, 23rd May, 2006, Riga, Latvia                                  ;;
;;   Aleksandr Smirnov (ASMI)                                          ;;
;;  For AutoCAD 2000 - 2008 (isn't tested in a next versions)           ;;
;;                                                                      ;;
;;                             http://www.asmitools.com                 ;;
;;                                                                      ;;
;; ==================================================================== ;;

(defun c:renlay (/ samObj filLst laySet layName Ans newName vlaLay)
  
  (vl-load-com)
  
  (if(setq samObj
	   (entsel "\nSelect object at wanted layer > "))
    (progn
      (setq filLst
	     (assoc 8(entget(car samObj))))
      (sssetfirst nil
	(setq laySet(ssget "_X" (list filLst))))
      (initget "Yes No")
      (setq Ans(getkword
		 (strcat "\n<<< Layer name: '"
			 (setq layName(cdr filLst))
			 "' >>>\nDo yo want to rename it [Yes/No]? <Yes>: ")))
      (if(null Ans)(setq Ans "Yes"))
      (if(= Ans "Yes")
	(progn
	  (if
	    (/= ""
		(setq newName
		       (getstring T "\nType new layer name: ")))
	    (progn
	      (setq vlaLay
		     (vla-Item
		       (vla-get-Layers
			 (vla-get-ActiveDocument
			   (vlax-get-acad-object))) layName))
	      (if
		(vl-catch-all-error-p
		  (vl-catch-all-apply
		    'vla-put-Name
		    (list vlaLay newName)))
		(princ "\n>>> Can't rename layer! <<< ")
		(princ
		  (strcat "\n<<< Layer '" layName
			  "' renamed to '" newName "' >>>"))
		); end if
	      ); end progn
	    ); end if
	  ); end progn
	); end if
      (sssetfirst nil nil)
     ); end progn
    ); end if
  (princ)
  ); end of c:renlay

(princ "\n[Info] http:\\\\www.AsmiTools.com [Info]")
(princ "\n[Info] Fast layer rename. Type RENLAY to run. [Info]")
