(defun c:flen1 (/ adoc ent pt *error*)
               ;|
*          " "
|;
  (defun loc:unhighlight (ent)
    (vl-catch-all-apply
      '(lambda ()
         (if ent
           (vla-highlight
             (cond
               ((= (type ent) 'ename) (vlax-ename->vla-object ent))
               (t ent)
               ) ;_ end of cond
             :vlax-false
             ) ;_ end of vla-highlight
           ) ;_ end of if
         ) ;_ end of lambda
      ) ;_ end of vl-catch-all-apply
    ) ;_ end of defun

  (defun *error* (msg)
    (loc:unhighlight ent)
    (vla-endundomark adoc)
    (princ msg)
    (princ)
    ) ;_ end of defun
  (vl-load-com)
  (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
  (while
    (and
      (not (vl-catch-all-error-p
             (vl-catch-all-apply
               '(lambda ()
                  (setq ent (car (entsel "\n  <> : ")))
                  ) ;_ end of lambda
               ) ;_ end of vl-catch-all-apply
             ) ;_ end of vl-catch-all-error-p
           ) ;_ end of not
      ent
      (wcmatch (strcase (cdr (assoc 0 (entget ent)))) "*LINE")
      (setq ent (vlax-ename->vla-object ent))
      ((lambda () (vla-highlight ent :vlax-true) t))
      (not (vl-catch-all-error-p
             (vl-catch-all-apply
               '(lambda ()
                  (setq pt (getpoint "\n   <> : "))
                  ) ;_ end of lambda
               ) ;_ end of vl-catch-all-apply
             ) ;_ end of vl-catch-all-error-p
           ) ;_ end of not
      pt
      ) ;_ end of and
     (vla-startundomark adoc)
     (loc:unhighlight ent)
     (vla-addmtext
       (vla-objectidtoobject adoc (vla-get-ownerid ent))
       (vlax-3d-point pt)
       0
       (strcat "%<\\AcObjProp Object(%<\\_ObjId "
               (vl-princ-to-string (vla-get-objectid ent))
               ">%).Length \\f \"%.30q0\">%"
               ) ;_ end of strcat
       ) ;_ end of vla-AddMText
     (vla-endundomark adoc)
     ) ;_ end of while
  (loc:unhighlight ent)
  (princ)
  ) ;_ end of defun

(defun c:tlen1 (/ adoc ent pt *error*)
               ;|
*          " "
|;
  (defun loc:unhighlight (ent)
    (vl-catch-all-apply
      '(lambda ()
         (if ent
           (vla-highlight
             (cond
               ((= (type ent) 'ename) (vlax-ename->vla-object ent))
               (t ent)
               ) ;_ end of cond
             :vlax-false
             ) ;_ end of vla-highlight
           ) ;_ end of if
         ) ;_ end of lambda
      ) ;_ end of vl-catch-all-apply
    ) ;_ end of defun

  (defun *error* (msg)
    (loc:unhighlight ent)
    (vla-endundomark adoc)
    (princ msg)
    (princ)
    ) ;_ end of defun
  (vl-load-com)
  (setq adoc (vla-get-activedocument (vlax-get-acad-object)))
  (while
    (and
      (not (vl-catch-all-error-p
             (vl-catch-all-apply
               '(lambda ()
                  (setq ent (car (entsel "\n  <> : ")))
                  ) ;_ end of lambda
               ) ;_ end of vl-catch-all-apply
             ) ;_ end of vl-catch-all-error-p
           ) ;_ end of not
      ent
      (wcmatch (strcase (cdr (assoc 0 (entget ent)))) "*LINE")
      (setq ent (vlax-ename->vla-object ent))
      ((lambda () (vla-highlight ent :vlax-true) t))
      (not (vl-catch-all-error-p
             (vl-catch-all-apply
               '(lambda ()
                  (setq pt (getpoint "\n   <> : "))
                  ) ;_ end of lambda
               ) ;_ end of vl-catch-all-apply
             ) ;_ end of vl-catch-all-error-p
           ) ;_ end of not
      pt
      ) ;_ end of and
     (vla-startundomark adoc)
     (loc:unhighlight ent)
     (vla-addtext
       (vla-objectidtoobject adoc (vla-get-ownerid ent))
       (rtos (vla-get-length ent) 2)
       (vlax-3d-point pt)
       2.5;  .          :)
       ) ;_ end of vla-AddMText
     (vla-endundomark adoc)
     ) ;_ end of while
  (loc:unhighlight ent)
  (princ)
  ) ;_ end of defun