;;;This WSNUM.LSP routine enables you to enter a prefix for sequentially
;;;numbered text which uses the Dtext routine to place text on the current
;;;layer in the current text style.
;;;
;;;This file has been edited from the 'cabnum.lsp' routine
;;;originally created by Elise Moss of Moss Designs.
;;;www.mossdesigns.com, August 2001
;;;
;;;
;;;Michael E. Beall
;;;michael.beall@autocadtrainerguy.com
;;;www.autocadtrainerguy.com, January 2002
;;;502.633.3994 (voice + FAX)
;;;Modified 4 August 2o11 - accepts decimal numbers for text height input
;;;                       - accepts only whole numbers for all other input
;;;                       - error in incrementation corrected
;;;                       - general tidying up and reorganisation of code

(defun c:wsnum	()

  ; get prefix 
  (setq prefix (getstring "\n < >? "))
  (if (= prefix "")
    (setq prefix " ")
  )

  ; get starting number
  (setq stnum (getint "\n  <1>? "))
  (if (= stnum nil)
    (setq stnum 1)
  )

  ; get increment
  (setq incrnum (getint "\n  <1>? "))
  (if (= incrnum nil)
    (setq incrnum 1)
  )

  ; get text height
  (setq txtht (getreal "\n   <1.0>: "))
  (if (= txtht nil)
    (setq txtht 1.0)
  )

  ; get insertion point
  (setq placepoint (getpoint "\n   : "))

  ; set placement string
  (setq label (strcat prefix "" (itoa stnum)))
  
  ; loop for all subsequent insertions, ESC or right click ends loop
  (while (/= placepoint nil)
    (setq label (strcat prefix " " (itoa stnum)))		; set placement string
    (command "_text" placepoint txtht "0" label)			; place text
    (setq stnum (+ stnum incrnum))				; increment number
    (setq placepoint (getpoint "\n   : "))	; get next insertion point
  )					;end while
  (princ)
)					; end defun
(prompt "\n WSNUM  . ")